/****************************************/
/*  Class to resolve hostnames		*/
/****************************************/
/* Start      : 03/08/2001		*/
/* Program ID : 			*/
/* Version    : 2.00			*/
/* End        : 			*/
/* Last Update: 03/08/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_VRESOLV2_H
#define _VLIB_VRESOLV2_H

/*
	3/8/200: v2.00:	Complete rewrite. simple and common resolving stuff
*/

#include "netdb.h"
#include "sys/types.h"
#include "sys/socket.h"
#include "netinet/in.h"
#include "string.h"

#include "v/mem/longline.h"
#include "v/mem/vtable.h"
#include "v/socket/ipaddr.h"

class VRESOLV
{
 private:
 	static int		usetcp;
 public:
 	VTABLE<LONGLINE>	name;	// the hostnames (A + CNAMES)
	int			names;	// the number of hostnames
	VTABLE<IPADDR>		ip;	// the ip numbers (PTR)
	int			ips;	// the number if ips
	int			error;	// the h_errno of the last request, or 0
 private:
	void	ddd		(VRESOLV &d);
	void	do_resolve	(const char *p);
	void	do_reverse	(IPLONG	ip);	// ip: NBO
	void	setdata		(hostent *h);
	void	clear		();
 public:
		VRESOLV		();
		~VRESOLV	();
		VRESOLV		(VRESOLV &d);
	VRESOLV operator=	(VRESOLV &d);

	void	operator=	(IPLONG ip);		// NBO ip address
	void	operator=	(const char *p);	// hostname or ip address in DDN
	void	operator=	(const LONGLINE& p);		// hostname or ip address in DDN
	void	operator=	(const IPADDR &ip);

	LONGLINE ipaddr		();	// return the first ip address in DDN (or "")

		operator LONGLINE();	// return the hostname (or "")
		operator IPLONG ();	// return the address in NBO (or -1)

	void	dump		();
	void	useTCP		(int usetcp=1);	// Using this, the connection will stay open
						// Call this with usetcp=0 to close the connection
};


#endif

