/****************************************/
/*					*/
/****************************************/
/* Start      : 22/09/2002		*/
/* Version    : 1.00			*/
/* Last Update: 22/09/2002		*/
/****************************************/

#ifndef _VLIB_V_FILE_FILEBUF_LINE_H
#define _VLIB_V_FILE_FILEBUF_LINE_H

#include "v/mem/longline.h"
#include "v/mem/dlist3.h"

#include "filebuf.h"

class FILEBUF_LINE : public FILEBUF
{
 private:
 protected:
 	DL_List<LONGLINE>	inlines, outlines;
 public:
 	int			maxline;	// Maximum length of a line
						// If this is negative, then a line longer than -maxline will cause an error
						// The line length is a bit fuzzy.. The real max line length
						// is the first multiple of 1024 greater than maxline
 private:
 	int		get_line	(int islast=0);	// get another line from input buffer // return: 1:OK, 0:No line was available
 	int		check_lines	();		// for each line call OnLine()	// stop, when a OnLine() returns NOT 0.
							// return the return value of last OnLine()

	int		do_check	(int islast=0);	// called by OnRead()
 protected:
 	int		OnRead		();
	void		OnError		();
 public:
 			FILEBUF_LINE	();
	virtual		~FILEBUF_LINE	();

	virtual int	OnLine		(const char *lin);	// Call this when a line came - for each line - Return: 0: OK, -1: close the connection
								// OnReject will NOT be called when OnLine returns -1
	virtual void	OnReject	();			// This will be called when an error occurs

	void		Write		(const char *line);	// Write a line
};


#endif

