/****************************************/
/*  Various simple file tasks		*/
/****************************************/
/* Start      : 10/11/2001		*/
/* Program ID : 			*/
/* Version    : 1.01			*/
/* End        : 			*/
/* Last Update: 09/02/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "fileops.h"

#include "fcntl.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "unistd.h"

/*
	09/02/2002 v1.01:	Added fgetline()
*/

/*
	Check if a file exists..
	Return:
		0: doesn't exist, or it is not accessible
		>0 : it exists. its type is returned (see FILE_IS_*)
*/
int	file_exist(const char *fn)
{
	struct stat	buf;
	int		ret,n;

	n=stat(fn,&buf);
	if (n==-1) ret=0;
	else
	{
		if (S_ISREG(buf.st_mode)) ret=FILE_IS_REG;
		else if (S_ISDIR(buf.st_mode)) ret=FILE_IS_DIR;
		else if (S_ISCHR(buf.st_mode)) ret=FILE_IS_CHAR;
		else if (S_ISBLK(buf.st_mode)) ret=FILE_IS_BLOCK;
		else if (S_ISFIFO(buf.st_mode)) ret=FILE_IS_FIFO;
		else ret=FILE_IS_MISC;
	}

	return(ret);
}

LONGLINE fgetline(FILE *f)
{
#define V_BUFSIZE 10
	char		buf[V_BUFSIZE+1];
	int		ok=0;
	int		k;
	LONGLINE	ret;

	buf[V_BUFSIZE]=0;

	ret="";
	while (!ok)
	{
		if (fgets(buf,V_BUFSIZE,f)!=NULL)
		{
			k=strlen(buf);
			if ((buf[k-1]=='\r') || (buf[k-1]=='\n'))	// EOL
				ok=1;
			ret+=buf;
		} else ok=1;
	}
	ret.ChopCRLF();

	return(ret);
#undef V_BUFSIZE
}

void	set_block(int fd, int block)
{
	fcntl(fd,F_SETFL,(block ? 0 : O_NONBLOCK));
}

