/****************************************/
/*					*/
/****************************************/
/* Start      : 30/03/2002		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 30/03/2002		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#define _EASYCGI_CC
#include "easycgi.h"

#include "v/mem/dlist3.cc"

int		argn;
const char	**argc;

struct	EASYCGI_VAR
{
	LONGLINE	name;
	union
	{
		LONGLINE	**ppll;
		long		**ppn;
	} data;
};

DL_List<EASYCGI_VAR *>	ECGI_VARS_LL;
DL_List<EASYCGI_VAR *>	ECGI_VARS_INT;

LONGLINE *set_cgi_var_ll(LONGLINE **ppll, const char *name)
{
	EASYCGI_VAR	*p;

	p=new EASYCGI_VAR;
	p->name=name;
	p->data.ppll=ppll;
	ECGI_VARS_LL.PushL(p);

	return(NULL);
}

long *set_cgi_var_int(long **ppn, const char *name)
{
	EASYCGI_VAR	*p;

	p=new EASYCGI_VAR;
	p->name=name;
	p->data.ppn=ppn;
	ECGI_VARS_INT.PushL(p);

	return(NULL);
}

CGI	cgi;

extern	void	cgi_pre_init();
extern	void	cgi_headers();
extern	int	cgi_main();

void	easycgi_get_vars()
{
	EASYCGI_VAR	**pp,*p;

	ECGI_VARS_LL.Rewind();
	while ((pp=ECGI_VARS_LL.Get_Next())!=NULL)
	{
		LONGLINE	*pll;

		p=*pp;
		pll=cgi.vars[p->name];
		if (pll==NULL)
		{
			*(p->data.ppll)=NULL;
		} else
		{
			*(p->data.ppll)=new LONGLINE;
			**(p->data.ppll)=*pll;
		}
	}

	ECGI_VARS_INT.Rewind();
	while ((pp=ECGI_VARS_INT.Get_Next())!=NULL)
	{
		LONGLINE	*pll;

		p=*pp;
		pll=cgi.vars[p->name];
		if (pll==NULL)
		{
			*(p->data.ppn)=NULL;
		} else
		{
			*(p->data.ppn)=new long;
			**(p->data.ppn)=atol(pll->p);
		}
	}
}

int main(int argn, const char *argc[])
{
	int	ret;

	::argn=argn;
	::argc=argc;

	cgi_pre_init();
	cgi.init();

	cgi_headers();
	cgi.print_headers();

	easycgi_get_vars();

	ret=cgi_main();

	return(ret);
}
