/****************************************/
/*					*/
/****************************************/
/* Start      : 30/03/2002		*/
/* Program ID : 			*/
/* Version    : 1.01			*/
/* End        : 			*/
/* Last Update: 30/03/2002		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_HTML_EASYCGI_H
#define _VLIB_V_HTML_EASYCGI_H

/*
 	21/5/2002:	v1.01:	Added NO_PRE_INIT and NO_CGI_HEADERS
 */

/*#include "v/lconfig.h"*/

#include "v/html/cgi.h"
#include "v/mem/longline.h"

LONGLINE *set_cgi_var_ll(LONGLINE **pll, const char *name);
long *set_cgi_var_int(long **pn, const char *name);

/*
	This will create a LONGLINE * called x
	which will hold the value of cgi variable y
	(or NULL if y is not available)
*/
#define	CGI_VAR_LL(x,y)	\
		LONGLINE	*x=set_cgi_var_ll(&x,y);
#define	CGI_VAR_INT(x,y)	\
		long		*x=set_cgi_var_int(&x,y);

/*#ifdef HAVE_STRINGIZE
#	define	CGI_VAR_LL(x)	CGI_VAR_LL(x,#x)
#	define	CGI_VAR_INT(x)	CGI_VAR_INT(x,#x)
#endif*/

#ifndef _EASYCGI_CC
extern	int		argn;
extern	const char	*argc[];
extern	CGI		cgi;
#endif

#endif

#define NO_PRE_INIT	void cgi_pre_init() {}
#define NO_CGI_HEADERS	void cgi_headers() {}

/*
	A typical EASYCGI program:

	#include "v/html/easycgi.h"

	CGI_VAR_LL(username,"username");
	CGI_VAR_LL(password,"password");

	// This is called before cgi things are initialized
	void cgi_pre_init()
	{
	}

	// Called before any header is printed.
	// Used to set cookies and headers
	void cgi_headers()
	{
		cgi.set_cookie("cookie","value",".domain.gr",10, // expire time in seconds
				"/~home");

		cgi.set_header("header","value");
	}

	// the main program
	int cgi_main()
	{
		if ((username==NULL) || (password==NULL))
		{
			printf("U hacker!\n");
		} else
		{
			printf("%s\n%s\n",username->p,password->p);
		}

		return(0);
	}
*/

