/****************************************/
/*  Susbstitute text in a text file     */
/****************************************/
/* Start      : 13/12/99                */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 13/12/99                */
/* Comments   :                         */
/*                                      */
/****************************************/

#define VLIB_V_HTML_HTML_PARSER_CC

#include "html_parser.h"
#include "v/misc/keytable2.cc"

Html_Parser::Html_Parser(VARTABLE *vars,int recursive)
{
	this->vars=vars;
	get_fixed2=NULL;
	this->recursive=recursive;
}

Html_Parser::~Html_Parser()
{
}

void Html_Parser::doit(const char *fn)
{
	load(fn,orig);
	do_substs(orig,final);
	orig="";	// free the memory
}

char *Html_Parser::get_fixed(char *c)
{
	return(NULL);	// stub. Derived classes will change this
}

char *Html_Parser::get_var(char *c)
{
	Variable	*var;
	char		*st=NULL;

	if (get_fixed2!=NULL) st=(*get_fixed2)(c);
	if (st==NULL) st=get_fixed(c);
	if (st==NULL)
	{
		var=(*vars)[c];
		if (var!=NULL)
		{
			st=get_text(var);
		}
		else st=NULL;
	}
	if ((recursive) && (st!=NULL))
	{
		LONGLINE l1,l2;
		l2=st;
		do_substs(l2,l1);
		tmp=l1;
		st=tmp.p;
	}
	return(st);
}

char *Html_Parser::get_text(Variable *var)
{
	LONGLINE	*ll;
	char		*p;
	
	ll=var->attr["TEXT"];
	if(ll==NULL) p=NULL;
	else p=ll->p;

	return(p);
}

/*
	kanei tis alages
	orig:	Arxiko string
	dest:	Teliko string
	vars:	Susbtitution table
*/
void Html_Parser::do_substs(const LONGLINE& orig, LONGLINE& dest)
{
	PARSE	pars;
	int	n;
	char	*c,*d;
	
	pars.AddSep('*');
	pars.Set(orig);
	n=0;
	dest="";
	while ((c=pars[n])!=NULL)
	{
		if (n%2)	// Even
		{
			if (!*c)
				dest+="*";
			else
			{
				d=get_var(c);
				if (d!=NULL) dest+=d;
			}
		} else	// Odd
		{
			dest+=c;
		}

		n++;
	}
}

void Html_Parser::set_func(char *(*func)(const char *))
{
	get_fixed2=func;
}

