/****************************************/
/*  Susbstitute text in a text file     */
/****************************************/
/* Start      : 13/12/99                */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 17/10/2001              */
/* Comments   :                         */
/*                                      */
/****************************************/

/*
	Read variables from a config file (class Read_Config)
	and store them to a VARTABLE (defined as KEYTABLE<Variable>)
	Each variable, may have as many attributes as needed.

	*** A special attribute named TEXT may exist. It's value is used ***
	*** by Html_Parser class, to susbstitute text from a file.       ***

	The whole config file and the whole text file is loaded into
	memory, and for an instance, the text file is hold twice in
	the memory, so it may not be used for large files.

	This was originaly create to parse html template pages, which
	explains the name of the class Html_Parser

	The format of the config file is:
	[Variable name]
	ATTRIBUTE=VALUE
	ATTRIBUTE={ VALUE }
	ATTRIBUTE={ VALUE
	VALUE}

	[Variable name]
	.
	.
	.

	When using ATTRIBUTE=VALUE,
	the spaces at the begginig and the end of VALUE are truncated.
	This means that
	TEXT = MY_TEXT   (with a trailing space)
	is the same as
	TEXT=MY_TEXT

	If this is not wanded, then {} may be used. In this case, the EXACTLY
	text contained in {} will be used.
	TEXT= { MY_TEXT }

	If {} are used, multiple lines may be specifed. The { MUST be after the =
	(in the same line).

	to use } or { in the attribute's value use \.
	ATTRIBUTE=\{TEST}
	(This is valid, bacause no { was found, so a } was not expected, but using \
	will not cause a problem.
	ATTRIBUTE={TEST\}TEST}
	To use \ in the text, prepend it with \.
	ATTRIBUTE=\\test\\

17/10/2001	v.1.0.1:	Added get_fixed2
				exterb get_fixed is tried before inherited get_fixed
*/

#ifndef _VLIB_V_HTML_HTML_PARSER_H
#define _VLIB_V_HTML_HTML_PARSER_H


#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "fcntl.h"
#include "unistd.h"


#include "v/mem/mem.h"
#include "v/mem/longline.h"
#include "v/mem/morelists.h"
#include "v/misc/keytable2.h"
#include "v/misc/configfile.h"
#include "v/string/parse.h"



class Html_Parser
{
 private:
 	LONGLINE		orig;	// Internal
 	LONGLINE		tmp;
	char			*(*get_fixed2)(const char *);	// extern get_fixed
	int			recursive;
 public:
 	LONGLINE		final;
 	KEYTABLE<Variable>	*vars;
 private:
 public:
		Html_Parser	(VARTABLE *vars, int recursive=1);
	virtual ~Html_Parser	();
 	void	doit		(const char *fn);
	void	do_substs	(const LONGLINE& orig, LONGLINE& dest);
	virtual	char *get_fixed	(char *c);	// Get the value of variable c.. For fixed variables. NULL if not available
	char	*get_var	(char *c);	// For variables loaded from config file. NULL if not available
	virtual char *get_text	(Variable *var);	// Return the text to be displayed.
	void	set_func	(char *(*func)(const char *));	// Set a function to act as get_fixed
};


#endif
