/****************************************/
/*					*/
/****************************************/
/* Start      : 08/09/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 08/09/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_IPC_SHM_H
#define _VLIB_V_IPC_SHM_H

#include "sys/types.h"

#define SHM_KEY_UNIQUE		(key_t)-2
#define SHM_KEY_PRIVATE		IPC_PRIVATE

class SHM
{
 private:
 	key_t	skey;
	int	shmid;
	size_t	shmsize;
 public:
 	void	*p;	// shm is attached here
 private:
	void	ddd		(SHM &d);
	void	create		();
	void	attach		();
	void	detach		();
 public:
		SHM		(size_t size, key_t tkey=SHM_KEY_UNIQUE);
		~SHM		();
		SHM		(SHM &d);
	SHM	operator=	(SHM &d);
	void	destroy		();
	key_t	key		();
	void	*get_data	();	// this will return a pointer to the data. NOT the shared memory segment
					// it mallocs a buffer and copies the data in it. free it when not needed
	size_t	size		();	// return the size of shm
	int	check		();	// return 0: if not available, 1: if available
	int	get_attachn	();	// return the number of attaches this shm has
};

#endif

