/****************************************/
/*  Double Linked List                  */
/****************************************/
/* Start      : 11/6/97                 */
/* Program ID :                         */
/* Version    : 2.01                    */
/* End        :                         */
/* Last Update: 25/7/99                 */
/* Comments   : Using templates         */
/*                                      */
/****************************************/

#ifndef _VLIB_V_MEM_DLIST_CC
#define _VLIB_V_MEM_DLIST_CC

#include "dlist3.h"

template <class ItemT> void DL_List<ItemT>::Construct()
{
	l=l2=NULL;
	Count=0;
//	last_search=NULL;
	moving=NULL;
	moving_pos=pos_end;
}

template <class ItemT> DL_List<ItemT>::DL_List(void)
{
	Construct();
}

template <class ItemT> void DL_List<ItemT>::Push(ItemT d)
{
	Push(&d);
}

template <class ItemT> void DL_List<ItemT>::PushL(ItemT d)
{
	PushL(&d);
}

template <class ItemT> void DL_List<ItemT>::Push(ItemT *data1)
{
	int	repos=0;

	if (((moving==NULL) && (moving_pos==pos_begin)) || (l==NULL))
		repos=1;

	if (!l)
	{
		l=new DListN;
		l->next=NULL;
		l->prev=NULL;
		l->data=*data1;
		l2=l;
	} else
	{
		DListN	*n;

		n=new DListN;
		n->next=l;
		n->prev=NULL;
		l->prev=n;
		n->data=*data1;
		l=n;
	}
	Count++;
	if (repos)
	{
		moving_pos=pos_mid;
		moving=l;
	}
}

template <class ItemT> void DL_List<ItemT>::PushL(ItemT  *data1)
{
	int	repos=0;

	if (((moving==NULL) && (moving_pos==pos_end)) || (l==NULL))
		repos=1;
	if (!l)
	{
		l=new DListN;
		l->next=NULL;
		l->prev=NULL;
		l->data=*data1;
		l2=l;
	} else
	{
		DListN	*n;
		n=new DListN;
		n->prev=l2;
		n->next=NULL;
		l2->next=n;
		n->data=*data1;
		l2=n;
	}
	Count++;
	if (repos)
	{
		moving_pos=pos_mid;
		moving=l2;
	}
}

template <class ItemT> ItemT *DL_List<ItemT>::Pop(void)
{
	DListN	*n;
	ItemT	*ret=NULL;

	if (l)
	{
		if (moving==l)
			moving=l->next;

		poped=l->data;
		n=l;
		l=l->next;
		delete(n);

		if (l)
			l->prev=NULL;
		else
			l2=NULL;

		Count--;
		ret=&poped;
	}
	return(ret);
}

template <class ItemT> ItemT *DL_List<ItemT>::PopL(void)
{
	DListN	*n;
	ItemT	*ret=NULL;

	if (l2)
	{
		if (moving==l)
			moving=l->prev;

		poped=l2->data;
		n=l2;
		l2=l2->prev;
		delete(n);

		if (l2)
			l2->next=NULL;
		else
			l=NULL;

		Count--;
		ret=&poped;
	}
	return(ret);
}

template <class ItemT> DL_List<ItemT>::~DL_List(void)
{
	ClearList();
}


template <class ItemT> void DL_List<ItemT>::Rewind(void)
{
	moving=NULL;
	moving_pos=pos_begin;
}

template <class ItemT> void DL_List<ItemT>::Seekend(void)
{
	moving=NULL;
	moving_pos=pos_end;
}

template <class ItemT> ItemT  *DL_List<ItemT>::Get_Next(void)
{
	ItemT	*ret=NULL;

	if (moving)
		moving=moving->next;
	else
	{
		if ((moving_pos==pos_begin) && (l))
		{
			moving=l;
			moving_pos=pos_mid;
		}
	}

	if (moving)
		ret=&(moving->data);
	else
	{
		ret=NULL;
		moving_pos=pos_end;
	}

	return(ret);
}

template <class ItemT> ItemT  *DL_List<ItemT>::Get_Prev(void)
{
	ItemT	*ret=NULL;

	if (moving)
		moving=moving->prev;
	else
	{
		if ((moving_pos==pos_end) && (l2))
		{
			moving=l2;
			moving_pos=pos_mid;
		}
	}

	if (moving)
		ret=&(moving->data);
	else
	{
		ret=NULL;
		moving_pos=pos_begin;
	}

	return(ret);
}

template <class ItemT> ItemT  *DL_List<ItemT>::GetCurrent(void)
{
	ItemT	*ret=NULL;

	if (moving)
		ret=&(moving->data);

	return(ret);
}

template <class ItemT> ItemT  *DL_List<ItemT>::GetN(int n)
{
	DListN	*p;
	ItemT	*ret;
	int	k;

	p=l;
	ret=NULL;
	k=0;

	while ((k<n) && (p))
	{
		p=p->next;
		k++;
	}

	if (p!=NULL) ret=&(p->data);

	return(ret);
}

template <class ItemT> ItemT  *DL_List<ItemT>::GetNL(int n)
{
	DListN	*p;
	ItemT	*ret;
	int	k;

	p=l2;
	ret=NULL;
	k=0;

	while ((k<n) && (p))
	{
		p=p->prev;
		k++;
	}

	if (p!=NULL) ret=&(p->data);

	return(ret);
}

template <class ItemT> void DL_List<ItemT>::ClearList(void)
{
	while (Pop());	// TODO: Make this faster
	moving=NULL;
	moving_pos=pos_begin;
}

template <class ItemT> void DL_List<ItemT>::RemoveCurrent(void)
{
	RemoveItem(moving);
}

template <class ItemT> void DL_List<ItemT>::RemoveItem(DListN *d)
{
	DListN	*dl;
	DListN	*dr;

	dl=d->prev;
	dr=d->next;

	if (moving==d)
		moving=dr;
	if (moving==NULL)
		moving_pos=pos_end;

	if (dl!=NULL)
		dl->next=dr;
	else
		l=dr;  // 23/7/97

	if (dr!=NULL)
		dr->prev=dl;
	else
		l2=dl; // 23/7/97

	Count--;
	delete(d);
}

template <class ItemT> void DL_List<ItemT>::RemoveItem(ItemT *d)
{
	DListN	*p;

	p=l;
	while ((p!=NULL) && (&(p->data)!=d))
	{
		p=p->next;
	}

	if (p!=NULL) // FOUND!!!
		RemoveItem(p);
}

template <class ItemT> ItemT  *DL_List<ItemT>::operator[](int n)
{
	return(GetN(n));
}

template <class ItemT> void DL_List<ItemT>::RemoveItem(int n)
{
	DListN	*p;
	int	k;

	p=l;
	k=0;

	while ((k<n) && (p))
	{
		p=p->next;
		k++;
	}

	if (p!=NULL)
		RemoveItem(p);
}

template <class ItemT> void DL_List<ItemT>::Append(DL_List<ItemT> &d)
{
	ItemT	*p;
	void	*save;

	save=d.SaveState(DL_LIST_STATE_NEW);
	d.Rewind();
	while ((p=d.Get_Next())!=NULL)
	{
		this->PushL(p);
	}
	d.RestoreState(save);
}

template <class ItemT> void DL_List<ItemT>::operator+=(DL_List<ItemT> &d)
{
	Append(d);
}

template <class ItemT> void DL_List<ItemT>::vvv(DL_List<ItemT> &d)
{
	ItemT	*p;
 	DListN	*pm,*pm2,*state_pm;
	MP	mpos;
	void	*save;

	Construct();

	pm=d.moving;
	mpos=d.moving_pos;
	state_pm=d.old_state.moving;
	old_state.type=d.old_state.type;
	old_state.poped=d.old_state.poped;
	pm2=NULL;	// Not-needed. Bypass gcc warning

	save=d.SaveState(DL_LIST_STATE_NEW);

	d.Rewind();
	while ((p=d.Get_Next())!=NULL)
	{
		PushL(p);
		if (pm==d.moving)	// if this is the d's moving
			pm2=l2;		// store ours
		if (state_pm==d.moving)	// Same for stored state
			old_state.moving=l2;
	}
	moving=pm2;	// now set the moving
	moving_pos=mpos;

	poped=d.poped;

	d.RestoreState(save);
}

template <class ItemT> DL_List<ItemT>::DL_List(DL_List<ItemT> &d)
{
	vvv(d);
}

template <class ItemT>  DL_List<ItemT> DL_List<ItemT>::operator=(DL_List<ItemT> &d)
{
 /* 25/7/99: First clear the old list */
	ClearList();
	vvv(d);
	return(*this);
}

template <class ItemT> void *DL_List<ItemT>::SaveState(void *_state)
{
	State	*state;

	state=(State *)_state;

	if (state==NULL)
		state=&old_state;
	else if (state==DL_LIST_STATE_NEW)
	{
		state=new State;
		state->type=1;
	}

	state->moving=moving;
	state->poped=poped;

	return(state);
}

template <class ItemT> void DL_List<ItemT>::RestoreState(void *_state)
{
	State	*state;

	state=(State *)_state;

	if (state==NULL)
		state=&old_state;

	moving=state->moving;
	poped=state->poped;

	if (state->type==1)
		delete(state);
}

template <class ItemT> DL_List<ItemT>::State::State()
{
	type=0;
	moving=NULL;
}

template <class ItemT> DL_List<ItemT>::DListN::DListN()
{
	next=NULL;
	prev=NULL;
}

template <class ItemT> DL_List<ItemT>::DListN::~DListN()
{
// delete(data);
}

template <class ItemT> void DL_List<ItemT>::Sort(sortfunc func)
{
	DListN		*pos,*lastpos;
	DListN		*t1,*t2;
	int		d=1;	// direction
	int		OK=0;
	int		ret;

	if (l==NULL)	// empty list. Dont' bother
		return;

	lastpos=pos=l;

	while (!OK)
	{
		if (d==1)
		{
			if (pos->next==NULL)	// the end
			{
				l2=pos;
				OK=1;
			} else
			{
				ret=func(&pos->data, &pos->next->data);
				if (ret<0)
				{
					t1=pos;			// xhncg them
					t2=pos->next;

					if (t1->prev!=NULL)
						t1->prev->next=t2;
					if (t2->next!=NULL)
						t2->next->prev=t1;

					t2->prev=t1->prev;
					t1->next=t2->next;
					t2->next=t1;
					t1->prev=t2;

					pos=t2;		// now pos points to element used to be pos->next (before the xchng)

					lastpos=pos->next;	// remember this

					d=-1;		// reverse the direction
				} else
				{
					pos=pos->next;
				}
			}
		} else
		{
			if (pos->prev==NULL)
			{
				l=pos;	// this is our new head
				
				pos=lastpos;

				d=1;	// go-on
			} else
			{
				ret=func(&pos->prev->data,&pos->data);
				if (ret<0)
				{
					t1=pos->prev;
					t2=pos;

					if (t1->prev!=NULL)
						t1->prev->next=t2;
					if (t2->next!=NULL)
						t2->next->prev=t1;

					t1->next=t2->next;
					t2->prev=t1->prev;
					t1->prev=t2;
					t2->next=t1;

					// now pos points to wherever it was pointing to.. but it has moved to the top
				} else
				{
					d=1;
//					pos=pos->next;
					pos=lastpos;
				}
			}
		}
	}
}

#endif


