/****************************************/
/*  Double Linked List (header)         */
/****************************************/
/* Start      : 11/6/97                 */
/* Program ID :                         */
/* Version    : 1.03                    */
/* End        :                         */
/* Last Update: 8/6/2002                */
/* Comments   : Using templates         */
/*                                      */
/****************************************/

/*
 8/6/2002: Added sorting function. (For N elements it does about (N^2)/4 comparisons)
 25/7/99: Memory leak!: when using operator= , the old data were not destroyed
          Bug!: When copying the object, poped was not copyied
 22/4/99: Added: Copy constructer for DL_List (fixes bug)
          Added: operator=() for DL_List (fixes bug)
 2/4/99: Found bug! RemoveCurrent2() would erase the next.. not the 'curent'
        (Corrected only in dlist2.cpp.. not in dlist.cpp)
 28/10/98: Added public: void RemoveCurrent2();
 26/10/98: Added public: void RemoveItem(long l);
 19/9/98 : Don't use memcpy. Use = instead. Doesn't work with
          strings.. suitable for objects..
 31/8/97: Added  public: ItemT *operator[](int n); Return(GetN(n))
 29/8/97: Added  public: long Count;  Number of items in the list
 20/8/97: Added  public: void RemoveItem(ItemT *d);
 23/7/97: Found bug! Error when removing first/last item with
          RemoveCurrent(). l and l2 should be updated!
 23/7/87: Found bug! In PushL() n->prev=l should be n->prev=l2
          Copy-Paste did this!
 6/7/97 : Use new/delete instead of malloc/free
          */

// INC == Incobatible

#ifndef _VLIB_V_MEM_DLIST_H
#define _VLIB_V_MEM_DLIST_H

#include "stdio.h"
#include "stdlib.h"

//#include "v/mem/mem.h"

#define DL_LIST_STATE_NEW	((void *)0x02)


template <class ItemT> class DL_List
// : public MEMORY
{
 private:
	struct DListN	// Node
	{
	 public:
		DListN	*next, *prev;
		ItemT	data;
	 public:
	 	DListN();
	 	~DListN();
	};

	DListN		*l;	//left (list?)
	DListN		*l2;	//right
	DListN		*moving;
	enum MP { pos_begin, pos_mid, pos_end } moving_pos;	// if moving==NULL, then if moving_pos==pos_begin, we are at l, else if moving_pos==pos_end, we are at l2
	ItemT		poped;
 public:
	typedef int (*sortfunc)(ItemT *p1, ItemT *p2);	// return: -1: p1>p2, 0: p1==p2, 1: p1<p2

 	struct State
	{
		int	type; // 0: normal, 1: auto-free this after a RestoreState
		DListN	*moving;
		ItemT	poped;
		State	();
	} old_state;
	long	Count;
 private:
	void	RemoveItem	(DListN *d);
	void	vvv		(DL_List<ItemT> &d);
	void	Construct	();
 public:
		DL_List		(void);
		~DL_List	(void);
		DL_List		(DL_List<ItemT> &d);
	DL_List<ItemT> operator=(DL_List<ItemT> &d);
	void	Push		(ItemT *data1); /* Add Element as first */
	void	Push		(ItemT d);
	void	PushL		(ItemT d);
	void	PushL		(ItemT *d);
	ItemT	*Pop		(void);		/* Remove first element */
	ItemT	*PopL		(void);		/* Remove last element */
	void	Rewind		(void);		// Init search
	void	Seekend		(void);
	ItemT	*Get_Next	(void);		// Find the next one
	ItemT	*Get_Prev	(void);		// Find the prev one
	ItemT	*GetCurrent	(void);		// Get the current
	ItemT	*GetN		(int n);	//Get the Nth element (1st = 0)
	ItemT	*GetNL		(int n);	//Get the Nth element from the end
	void	ClearList	(void);
	void	RemoveCurrent	(void); //Remove current from list -- Also, like RemoveCurrent2()
	void	RemoveItem	(ItemT *d); //Find D and remove it *1*

	ItemT	*operator[]	(int n);
	void	RemoveItem	(int n);  //Find the Nth element and remove it

	void	Append		(DL_List<ItemT> &d); /* Append a list to this one */
	void	operator+=	(DL_List<ItemT> &d); /*      >>      >>     */

	void	*SaveState	(void *_state=NULL);	// Save and restore the current state.
	void	RestoreState	(void *_state=NULL);	// if state !=NULL, then use this one, else use old_state
							// if state==DL_LIST_STATE_NEW then malloc a new State
							// Parameter should be a State type, or NULL, or DL_LIST_STATE_NEW

	void	Sort		(sortfunc func);	// Sort the list using func to compare items
};


#endif


/*
 *1*  :  Match the pointer. Bug free???????
 */
