/****************************************/
/*  More kinds of lists                 */
/****************************************/
/* Start      : 30/10/98                */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 23/7/99                 */
/* Comments   :                         */
/*                                      */
/****************************************/

#include "morelists.h"
#include "v/mem/dlist3.cc"
#include "v/lconfig.h"

/*
 23/7/99: Found bug in NUMLIST:
   in NUMLIST::vvv():
    this->p=(long *)list.p;   was   this->p=p.p;
    but p.p was p.list.p, so after the function returned, this->p was incorrect

*/

#ifndef _NUMLIST_BLOCKSIZE
#define _NUMLIST_BLOCKSIZE _LONGLINE_BLOCKSIZE
#endif

#define INIT_CMDLIST_SIZE 50  // 50 commands

//#define NUMLIST	NUMLIST_OLD

NUMLIST::NUMLIST()
{
 Resize(INIT_CMDLIST_SIZE);
 p=(long *)list.p;
 cmdN=0;
}

NUMLIST::~NUMLIST()
{
}

void NUMLIST::Resize(long l)
{
 list.Setsize((l+2)*sizeof(long));
 p=(long *)list.p;
 maxcmdN=l;
}

void NUMLIST::Add(long l)
{
 if (cmdN>maxcmdN) Resize(maxcmdN+_NUMLIST_BLOCKSIZE);
  p[cmdN++]=l;
}

void NUMLIST::Del(long l)
{
 long n;

 if ((n=Exist(l))!=-1)  // Find the command
 {
  p[n]=p[cmdN-1];  // Replace it with the last one
  cmdN--;
  goto OUT;  // Am I lame.. Yes I am..
 }
 OUT:
 return;
}

long NUMLIST::Exist(long l)
{
 long n,m;

 m=-1;
 for (n=0;((n<cmdN) && (m==-1));n++)
 {
  if (p[n]==l)
   m=n;
 }

 return(m);
}

NUMLIST::NUMLIST(NUMLIST &p)
{
 vvv(p);
// this->operator=(p);
}

void NUMLIST::vvv(NUMLIST& p)
{
 list=p.list;
 cmdN=p.cmdN;
// Resize(p.maxcmdN);
 maxcmdN=p.maxcmdN;
 this->p=(long *)list.p; // was this->p=p.p;

}

NUMLIST NUMLIST::operator=(NUMLIST& p)
{
 // NUMLIST::NUMLIST(p);
 vvv(p);
 return(*this);
}

long NUMLIST::operator[](long l)
{
 //return(Exist(l));
 return(p[l]);
}

long NUMLIST::Get(long l)
{
 long n;

 n=-1;
 if ((l<cmdN) && (l>=0))
  n=p[l];
 
 return(n);
}

void NUMLIST::Clear()
{
 cmdN=0;
}

//#undef NUMLIST

/*STRLIST::STRLIST()
{
 count=0L;
}

STRLIST::~STRLIST()
{
}

STRLIST::STRLIST(STRLIST& p)
{
// this->operator=(p);
 vvv(p);
}

void STRLIST::vvv(STRLIST& p)
{
// LONGLINE *s;

// list.ClearList();
// count=0L;

// p.list.Rewind();

// while ((s=p.list.Get_Next())!=NULL)
//  Add(*s);
 list=p.list;
 count=p.count;
}

STRLIST STRLIST::operator=(STRLIST& p)
{
 // STRLIST::STRLIST(p);
 vvv(p);
 return(*this);
}

void STRLIST::Add(const LONGLINE& p)
{
 list.PushL(p);
 count++;
}

int STRLIST::GoTo(const LONGLINE& p)
{
 int n=0;
 LONGLINE *l;

 list.Rewind();
 l=list.Get_Next();

 while ((!n) && (l!=NULL))
 {
  if(*l==p) n=1;  else l=list.Get_Next();
 }

 return(n);
}

int STRLIST::Del(const LONGLINE& p)
{
 int n;

 if ((n=GoTo(p))!=0)
  list.RemoveCurrent();

 return(n);
}

int STRLIST::Exist(const LONGLINE& p)
{
 return(GoTo(p));
}

int STRLIST::operator[](const LONGLINE& p)  // Same as exist
{
 return(Exist(p));
}

void STRLIST::Clear()
{
 list.ClearList();
 count=0;
}

LONGLINE *STRLIST::Get(long l)
{
 return(list[l]);
}

void STRLIST::Rewind()
{
 list.Rewind();
}

LONGLINE *STRLIST::Get_Next()
{
 return(list.Get_Next());
}

*/

