/****************************************/
/*					*/
/****************************************/
/* Start      : 30/08/2002		*/
/* Version    : 1.00			*/
/* Last Update: 30/08/2002		*/
/****************************************/

#include "strlist.h"

#include "v/file/fileops.h"

#include "v/mem/dlist3.cc"

STRLIST::STRLIST()
{
	count=0L;
	unique=0;
	nocase=0;
}

STRLIST::~STRLIST()
{
}

STRLIST::STRLIST(STRLIST& p)
{
// this->operator=(p);
	vvv(p);
}

void STRLIST::vvv(STRLIST& p)
{
	list=p.list;
	count=p.count;
	unique=p.unique;
	nocase=p.nocase;
}

STRLIST STRLIST::operator=(STRLIST& p)
{
	vvv(p);
	return(*this);
}

void STRLIST::operator+=(STRLIST& p)
{
	LONGLINE	*pll;

	p.Rewind();
	while ((pll=p.Get_Next())!=NULL)
	{
		this->Add(*pll);
	}
}

void STRLIST::Add(const LONGLINE& p)
{
	if (!unique || !Exist(p))
	{
		list.PushL(p);
		count++;
	}
}

int STRLIST::GoTo(const LONGLINE& p)
{
	LONGLINE	*l;

	list.Rewind();

	while ((l=list.Get_Next())!=NULL)
	{
		if ((nocase && (!strcasecmp(l->p,p.p)))
			|| (!nocase && (*l==p)))
			return(1);
	}

	return(0);
}

int STRLIST::Del(const LONGLINE& p)
{
	int	n;

	if ((n=GoTo(p))!=0)
		list.RemoveCurrent();

	return(n);
}

int STRLIST::Exist(const LONGLINE& p)
{
	return(GoTo(p));
}

int STRLIST::operator[](const LONGLINE& p)  // Same as exist
{
	return(Exist(p));
}

void STRLIST::Clear()
{
	list.ClearList();
	count=0;
}

LONGLINE *STRLIST::Get(long l)
{
	return(list[l]);
}

void STRLIST::Rewind()
{
	list.Rewind();
}

LONGLINE *STRLIST::Get_Next()
{
	return(list.Get_Next());
}

int	STRLIST::FromFile(const char *fn, int flags)
{
	int	ret;

	Clear();
	ret=AppendFromFile(fn,flags);
	
	return(ret);
}

int	STRLIST::AppendFromFile(const char *fn, int flags)
{
	FILE		*f;
	LONGLINE	ll;
	int		cnt=0;

	f=fopen(fn,"rt");

	if (f==NULL)
		return(-1);

	while (!feof(f))
	{
		ll=fgetline(f);
		if (flags & STRLIST_FL_LOWER)
			ll.Lowercase();
		else if (flags & STRLIST_FL_UPPER)
			ll.Uppercase();

		if ((!(flags & STRLIST_FL_EMPTY)) ||
			(ll!=""))
		{
			Add(ll);
			cnt++;
		}
	}
	if (ll=="")	// this is the last false line
	{
		list.PopL();
		cnt--;
	}
	
	fclose(f);

	return(cnt);
}

void	STRLIST::SetUnique(int n)
{
	unique=(n ? 1 : 0);
}

void	STRLIST::SetNocase(int n)
{
	nocase=(n ? 1 : 0);
}
