/****************************************/
/*					*/
/****************************************/
/* Start      : 30/08/2002		*/
/* Version    : 1.01			*/
/* Last Update: 30/08/2002		*/
/****************************************/

#ifndef _VLIB_V_MEM_STRLIST_H
#define _VLIB_V_MEM_STRLIST_H

#include "v/mem/longline.h"
#include "v/mem/dlist3.h"

/*
	30/8/2002 v1.01:	Reformating and some additions to orignal STRLIST
*/

class STRLIST // Strings list.
{
 private:
 	int	unique;
	int	nocase;
 public:
	DL_List<LONGLINE>	list;
	long			count;
 private:
	int		GoTo		(const LONGLINE &p);	// Go to the element. Return 0 if not found (else 1)
	void		vvv		(STRLIST& p);
 public:
			STRLIST		();
			~STRLIST	();
			STRLIST		(STRLIST& p);

	STRLIST		operator=	(STRLIST& p);
	int		operator[]	(const LONGLINE& p);	// Same as exist
	void		operator+=	(STRLIST& p);	// Append a string list

	void		Add		(const LONGLINE& p);
	int		Del		(const LONGLINE& p);	// Return 1 if found, else 0
	int		Exist		(const LONGLINE& p);
	void		Clear		();
	LONGLINE	*Get		(long l);
	void		Rewind		();
	LONGLINE	*Get_Next	();

	int		FromFile	(const char *fn, int flags);	// Read list from file
	int		AppendFromFile	(const char *fn, int flags);	// Append data to list from file
									// Return number of elements, or -1 on error
	void		SetUnique	(int n);	// Elements should be unique
	void		SetNocase	(int n);	// Searches are not case sensitive
};

#define	STRLIST_FL_LOWER	1	// convert to lowercase
#define STRLIST_FL_UPPER	2	// convert to uppercase
#define STRLIST_FL_EMPTY	4	// add empty lines too

#endif

