/****************************************/
/*  Tree class (header)                 */
/****************************************/
/* Start      : 15/12/98                */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 15/12/98                */
/* Comments   :                         */
/*                                      */
/****************************************/

#ifndef _VLIB_V_MEM_TREE_H
#define _VLIB_V_MEM_TREE_H

//#include "dlist.hpp"
#include "v/misc/keytable2.h"
#include "v/mem/longline.h"


template <class T> class TREE_NODE
{
 private:
 public:
  T Data;
  TREE_NODE<T>* Prev;
  DL_List<TREE_NODE<T>*> Next;
  TREE_NODE<T> *curchild;
 private:
  TREE_NODE vvv(TREE_NODE<T>& p)
  {
   Data=p.Data;
   Prev=p.Prev;
   Next=p.Next;
   curchild=p.curchild;
  }
 public:
  TREE_NODE(TREE_NODE *prev=NULL) { Prev=prev; curchild=NULL;}
  ~TREE_NODE() {};
  TREE_NODE(TREE_NODE& p) { vvv(p); }
  TREE_NODE operator=(const TREE_NODE& p) { return(vvv(p)); }
};

template <class T> class TREE
{
 private:
  TREE_NODE<T> Head;
  TREE_NODE<T> *moving;
//  TREE_NODE<T> *curchild; // The child we are examining
 public:
  long Count;   // Do we need this ???
 private:
  void DelAll(TREE_NODE<T>* p);  // Erase all the childs and then this
  void DelAllChilds(TREE_NODE<T>* p);  // Erase all the childs
  void Del(TREE_NODE<T>* p);  // Erase only this.. **WARNING** This may leave trash in memory
  TREE_NODE<T> *NewNode(T *p);
  void DelNode(TREE_NODE<T>* p);
 public:
  TREE();
  TREE(T *head);
  TREE(T &head);
  ~TREE();
  void Append(T *Data); // Append to current as child(moving);
  void Append(T &Data); // Append to current as child(moving);
  void Delete(); // Delete current(recursively) and move pointer (moving) to the previous
  void Unlink(); // Unlink current and ... previous. Append Next, to Prev->Next
  void DelAllChilds(); // Erase all the childs of the current (moving)
  void cRewind(); // Rewind childs
  T *cGet_Next(); // Get Next child
  T *Get_Current(); // Get the current node's data
  T *Advance(); // Go to the current child (curchild) (return pointer to its data)
  void GoBack();  // Go to the previous
  void Set(T *Data); // Set current's data
  void Set(T &Data); // Set current's data
  void GotoHead();
  void Init(T &head); // Re-initialize
  void AppendAA(T *Data); // Apend to current as child and advance to it
  void AppendAA(T &Data); // Apend to current as child and advance to it
};


#endif
