/****************************************/
/*  Generalized config file             */
/****************************************/
/* Start      : 3/1/2000                */
/* Program ID :                         */
/* Version    : 1.03                    */
/* End        :                         */
/* Last Update: 2/8/2001                */
/* Comments   :                         */
/*                                      */
/****************************************/

/*
	2/8/2001	v1.03:	Read/Write, load/save return fail/succeed (0/1)
	1/5/2001	v1.02:	Added free(buf) in load()
				Added return(c) in ignore_SCRLF. (It was a bug no to have it)
	24/6/2000	v1.01:	BUG fixed in Read_Config::do_var()
*/

#define _VLIB_V_MISC_CONFIGFILE_CC

#include "configfile.h"
#include "v/misc/keytable2.cc"

//char	*ignore_SCRLF(char *c);				// pass through spaces, CRs, LFs
//char	*get_block(char *c, LONGLINE& dest);		// get a block (all chars until EOL, or everything included in {}
//void	load(const char *fn, LONGLINE& dest);		// Load a file in dest
//void	save(const char *fn,const LONGLINE& src);	// Save src in fn


Variable::Variable()
{
	name="";
}

Variable::~Variable()
{
}

Variable::Variable(Variable &d)
{
	ddd(d);
}

Variable Variable::operator=(Variable &d)
{
	ddd(d);
	return (*this);
}

void Variable::clear()
{
	name="";
	attr.ClearTable();
}

void Variable::ddd(Variable &d)
{
	name=d.name;
	attr=d.attr;
}



Read_Config::Read_Config(VARTABLE *vars)
{
	this->vars=vars;
}

Read_Config::~Read_Config()
{
}

int Read_Config::Read(const char *fn)
{
	int	ret;

	ret=load(fn,conf);
	if (ret)
	{
		parse();
		conf="";	// free the memory
	}

	return(ret);
}


void Read_Config::do_var(char *c)
{
	PARSE		pars;
	LONGLINE	name;
	Variable	var,*v;
	LONGLINE	attr_name;
	LONGLINE	attr_value;
	LONGLINE	tmp,*ll;
	char		*d;
	int		err=0;	// if err=1, don't add the current attribute
	
	name="";
	d=ignore_SCRLF(c);
	while ((*d!=']') && (*d) && (*d!=' ')) {name+=*d; d++;}	// Get the name (ignore trailing spaces)
	while ((*d!=']') && (*d)) d++;	// Find ] (in case of spaces)
	d++;	// pass the ]
	d=ignore_SCRLF(d);
	
	while (*d)
	{
		tmp="";
		err=0;
		d=ignore_SCRLF(d);
		while ((*d) && (*d!='=') && (*d!=' '))	// Get the attr name
		{
			tmp+=*d;
			d++;
		}
		if (!*d) err=1;
		while ((*d) && (*d!='=')) d++;	// find the =
		if (!*d) err=1;
		if (!err)
		{
			d++;	// pass the =
			d=get_block(d,attr_value);
			attr_name=tmp;
			attr_name.Uppercase();
			ll=var.attr[attr_name];
			if (ll==NULL)
				var.attr.Add(attr_name,attr_value);
			else
				*ll=attr_value;
		}
	}
	
	v=(*vars)[name];
	var.name=name;
	name.Uppercase();
	if (v==NULL)
		vars->Add(name,var);
	else
		*v=var;
}


void Read_Config::parse()
{
	PARSE	pars;
	int	n;
	char	*c;

	pars.AddSep('[');
	pars.Set(conf);
	n=1;
	
	while((c=pars[n])!=NULL)
	{
		do_var(c);
		n++;
	}
}

void Read_Config::create_line()
{
	Variable	*var;
	LONGLINE	*pll1,*pll2,*pll3,tmp;
	char		*ch;
	
	vars->Rewind();
	conf="";
	while ((pll1=vars->Get_Next())!=NULL)	// For every variable
	{
		var=(*vars)[*pll1];
		tmp="[";
		tmp+=var->name;
		tmp+="]\n";
		conf+=tmp;
		var->attr.Rewind();
		while ((pll2=var->attr.Get_Next())!=NULL)	// for every attribute
		{
			pll3=var->attr[*pll2];
			tmp=*pll2;
			tmp+="={";
			ch=pll3->p;
			while(*ch)
			{
				switch(*ch)
				{
					case '{':
						tmp+="\\{";
						break;
					case '}':
						tmp+="\\}";
						break;
					default:
						tmp+=*ch;
						break;
				}
				ch++;
			}
			tmp+="}\n";
			conf+=tmp;
		}
		conf+="\n";
	}
}

int Read_Config::Write(const char *fn)
{
	int	ret;

	create_line();
	ret=save(fn,conf);

	return(ret);
}

char *ignore_SCRLF(char *c) // pass through spaces, CRs, LFs
{
	while ((*c=='\n') || (*c=='\r') || (*c==' ') || (*c=='\t')) c++;
	return(c);	// Added 1/5/2001 (Was a bug!)
}

char *ignore_Spaces(char *c) // pass through spaces
{
	while ((*c==' ') || (*c=='\t')) c++;
	return(c);
}

char *get_block(char *c, LONGLINE& dest)
{
	LONGLINE	tmp;
	char		*d,*d2,*d3;
//	int type=0;	// type: 0: single line, 1: {mplampla}
	char ch;

	/*
		at the end:
		d: begin of the data
		d2: end of the data
		d3: end of the block (if there is a } at the end, *d3=='}' and d2==d3-1)
	*/

	tmp="";
	d=ignore_Spaces(c);	// In case of no value (27/8/2002)
	if ((*d=='\r') || (*d=='\n'))
	{
		dest="";
		return(c);
	}
	d=ignore_SCRLF(c);
	if ((*d) && (*d=='{'))
	{
		d++;
//		type=1;
		d3=d;
		while ((*d3!='}') && (*d3))
		{
			if (*d3=='\\') d3++;
			if (*d3) d3++;
		}
		if (*d3) {d2=d3; d3++;} else d2=NULL;
	} else
	{
//		type=0;
		d2=strchr(d,'\n');
		d3=strchr(d,'\r');
		if (d2==NULL) d2=d3;
		else if ((d3!=NULL) && (d3<d2)) d2=d3;
		// Now d2 is the end (or NULL)
		if (d2==NULL)
			d2=strchr(d,0);	// find the end
		d2--;
		while (*d2==' ') d2--;
		d2++;
		d3=d2;
	}
	if (d2!=NULL)
	{
		ch=*d2;
		*d2=0;
		tmp=d;
		*d2=ch;
	}

	dest=tmp;
	return(d3);
}

int load(const char *fn, LONGLINE& dest)
{
	char	*buf;
	int	s;
	int	fd;
	int	ret=0;

	fd=open(fn,O_RDONLY);
	if (fd!=-1)
	{
		ret=1;
		buf=(char *)malloc(1024+1);
		buf[1024]=0;
		dest="";
		lseek(fd,0,SEEK_SET);

		do {
			s=read(fd,buf,1024);
			if (s>0)
			{
				buf[s]=0;
				dest+=buf;
			}
		} while (s>0);

		close(fd);

		free(buf);	// 1/5/2001
	}

	return(ret);
}


int save(const char *fn, const LONGLINE& src)
{
	int	fd;
	int	ret=0;

//	fd=open(fn,O_WRONLY | O_CREAT | O_TRUNC | S_IRUSR | S_IWUSR);
	fd=creat(fn,S_IRUSR | S_IWUSR);
	if (fd>=0)
	{
		ret=1;
		write(fd,src.p,strlen(src));
		close(fd);
	}

	return(ret);
}
