/****************************************/
/*  General configs                     */
/****************************************/
/* Start      : 3/1/2000                */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 2/8/2001                */
/* Comments   : Databases               */
/*                                      */
/****************************************/

#include "generalconfigfile.h"
#include "v/misc/keytable2.cc"

/*
	2/8/2001: v1.01:	+ Read/Write return fail/succedd (0/1)
*/

#ifdef _VARNAMES_UPPERCASE
#       define VARNAME_FORM(x)  x.Uppercase()
#else
#       if defined(_VARNAMES_LOWERCASE)
#               define VARNAME_FORM(x)  x.Uppercase()
#       else
#               define VARNAME_FORM(x)
#       endif
#endif

#ifdef _ATTRIBNAMES_UPPERCASE
#       define ATTRIBNAME_FORM(x)       x.Uppercase()
#else
#       if defined(_ATTRIBNAMES_LOWERCASE)
#               define ATTRIBNAME_FORM(x)       x.Uppercase()
#       else
#               define ATTRIBNAME_FORM(x)
#       endif
#endif

GeneralConfigEntry::GeneralConfigEntry()
{
        Name="";
}
GeneralConfigEntry::~GeneralConfigEntry()
{
}

GeneralConfigEntry::GeneralConfigEntry(GeneralConfigEntry &d)
{
        ddd(d);
}

GeneralConfigEntry GeneralConfigEntry::operator=(GeneralConfigEntry &d)
{
        ddd(d);
        return (*this);
}

void GeneralConfigEntry::ddd(GeneralConfigEntry &d)
{
        Name=d.Name;
        fFlags=d.fFlags;
        iFlags=d.iFlags;
        sStrings=d.sStrings;
        lLists=d.lLists;
}

void GeneralConfigEntry::Clear()
{
        Name="";
        fFlags.ClearTable();
        iFlags.ClearTable();
        sStrings.ClearTable();
        lLists.ClearTable();
}

/*-------------------------------------------------------------------------------------------*/

GeneralConfigFile::GeneralConfigFile()
{
}

GeneralConfigFile::~GeneralConfigFile()
{
}

GeneralConfigFile::GeneralConfigFile(GeneralConfigFile &d)
{
        ddd(d);
}

GeneralConfigFile GeneralConfigFile::operator=(GeneralConfigFile &d)
{
        ddd(d);
        return (*this);
}

void GeneralConfigFile::ddd(GeneralConfigFile &d)
{
        data=d.data;
}

int GeneralConfigFile::Read(const char *fn)
{
        GeneralConfigEntry      tmp;
        VARTABLE                vars;
        Read_Config             conf(&vars);
        LONGLINE                *pll1,*pll2,*pll3;        // Pointers doesn't cost :)
        Variable                *var;
        LONGLINE                ll1,ll2,ll3;
        double                  f;
        long                    l;
        STRLIST                 strlist;
        PARSE                   pars;
        int                     n;
        char                    *st;
	int			ret;


        ret=conf.Read(fn);
	if (!ret) return(0);
//      vars=conf.vars;
        vars.Rewind();
        pars.AddSep(',');

        while ((pll1=vars.Get_Next())!=NULL)    // For each variable
        {
                tmp.Clear();
                var=vars[*pll1];
                tmp.Name=var->name;
                var->attr.Rewind();
                while ((pll2=var->attr.Get_Next())!=NULL)       // For each attribute
                {
                        pll3=var->attr[*pll2];
                        ll1=*pll2;
                        ATTRIBNAME_FORM(ll1);
                        switch( tolower(ll1[0]) )
                        {
                                case 'f':                               // float
                                        f=atof(pll3->p);
                                        ll2=&(ll1.p[1]);
                                        tmp.fFlags.Add(ll2,f);
                                        break;
                                case 'i':                               // integer
                                        l=atol(pll3->p);
                                        ll2=&(ll1.p[1]);
                                        tmp.iFlags.Add(ll2,l);
                                        break;
                                case 's':                               // String
                                        ll2=&(ll1.p[1]);
                                        tmp.sStrings.Add(ll2,*pll3);
                                        break;
                                case 'l':                               // STRLIST
                                        pars.Set(*pll3);
                                        n=0;
                                        strlist.Clear();
                                        while ((st=pars[n])!=NULL)
                                        {
                                                ll2=st;
                                                strlist.Add(ll2);
                                                n++;
                                        }
                                        ll2=&(ll1.p[1]);
                                        tmp.lLists.Add(ll2,strlist);
                                        break;
                                default:                                // Unknown
                                        break;
                        }

                }
                ll1=var->name;
                VARNAME_FORM(ll1);
                data.Add(ll1,tmp);
        }

	return(1);
}

int GeneralConfigFile::Write(const char *fn)
{
        VARTABLE                vars;
        Variable                var;
        Read_Config             conf(&vars);
        GeneralConfigEntry      *gce;
        LONGLINE                *pll1,*pll2,*pll3,tmp1,tmp2;
        double                  *pd;
        long                    *pl;
        STRLIST                 *pstrlist;
        char                    str[101];       // temp
	int			ret;

        data.Rewind();
        while((pll1=data.Get_Next())!=NULL)     // for every variable
        {
                var.clear();
                gce=data[*pll1];

                gce->fFlags.Rewind();
                var.name=gce->Name;

                gce->iFlags.Rewind();
                while ((pll2=gce->iFlags.Get_Next())!=NULL)     // for all the i flags create an attribute
                {
                        pl=gce->iFlags[*pll2];
                        tmp1="i";
                        tmp1+=*pll2;            // this is the name
                        sprintf(str,"%ld",*pl);
                        tmp2=str;               // this is the value
                        var.attr.Add(tmp1,tmp2);
                }

                gce->fFlags.Rewind();
                while ((pll2=gce->fFlags.Get_Next())!=NULL)     // for all the f flags create an attribute
                {
                        pd=gce->fFlags[*pll2];
                        tmp1="f";
                        tmp1+=*pll2;            // this is the name
                        sprintf(str,"%f",*pd);
                        tmp2=str;               // this is the value
                        var.attr.Add(tmp1,tmp2);
                }

                gce->sStrings.Rewind();
                while ((pll2=gce->sStrings.Get_Next())!=NULL)   // for all the strings create an attribute
                {
                        pll3=gce->sStrings[*pll2];
                        tmp1="s";
                        tmp1+=*pll2;            // this is the name
                        var.attr.Add(tmp1,*pll3);
                }

                gce->lLists.Rewind();
                while ((pll2=gce->lLists.Get_Next())!=NULL)     // for all the lists create an attribute
                {
                        pstrlist=gce->lLists[*pll2];
                        tmp1="l";
                        tmp1+=*pll2;            // this is the name

                        tmp2="";
                        pstrlist->Rewind();
                        while((pll3=pstrlist->Get_Next())!=NULL)
                        {
                                tmp2+=*pll3;
                                tmp2+=",";
                        }
                        tmp2--;

                        var.attr.Add(tmp1,tmp2);
                }

                vars.Add(gce->Name,var);
        }
        ret=conf.Write(fn);

	return(ret);
}

