/****************************************/
/*  General configs (header)            */
/****************************************/
/* Start      : 3/1/2000                */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 02/08/2001              */
/* Comments   : Databases               */
/*  Parmeno apo to bot!                 */
/****************************************/

#ifndef _VLIB_V_MISC_GENERALCONFIGFILE_H
#define _VLIB_V_MISC_GENERALCONFIGFILE_H

#include "v/mem/longline.h"
#include "v/mem/morelists.h"
#include "v/misc/configfile.h"
#include "v/misc/keytable2.h"
#include "v/string/parse.h"

/*
        define _ATTRIBNAMES_NOCHANGES and _VARNAMES_NOCHANGES
        to prevent case-change to variable names and attribute names
*/

#if (!defined(_ATTRIBNAMES_UPPERCASE) && !defined(_ATTRIBNAMES_LOWERCASE) && !defined(_ATTRIBNAMES_NOCHANGE))

#define _ATTRIBNAMES_UPPERCASE          // This will turn all attribute names to uppercase
//#define _ATTRIBNAMES_LOWERCASE                // This will turn all attribute names to lowercase

#endif

#if (!defined(_VARNAMES_UPPERCASE) && !defined(_VARNAMES_LOWERCASE) && !defined(_VARNAMES_NOCHANGE))

#define _VARNAMES_UPPERCASE             // This will turn all variable names to uppercase
//#define _VARNAMES_LOWERCASE           // This will turn all variable names to lowercase

#endif

/*
        GeneralConfigEntry works as a data holder.
        It stores variable types
*/
class GeneralConfigEntry
{
 private:
 public:
        LONGLINE                Name;
        KEYTABLE<double>        fFlags;
        KEYTABLE<long>          iFlags;
        KEYTABLE<LONGLINE>      sStrings;
        KEYTABLE<STRLIST>       lLists;
 private:
        void ddd(GeneralConfigEntry &d);
 public:
        GeneralConfigEntry();
        ~GeneralConfigEntry();
        GeneralConfigEntry(GeneralConfigEntry &d);
        GeneralConfigEntry operator=(GeneralConfigEntry &d);
        void Clear();
};

class GeneralConfigFile
{
 private:
 public:
        KEYTABLE<GeneralConfigEntry>    data;
 private:
        void ddd(GeneralConfigFile &d);
 public:
        GeneralConfigFile();
        ~GeneralConfigFile();
        GeneralConfigFile(GeneralConfigFile &d);
        GeneralConfigFile operator=(GeneralConfigFile &d);
        int Read(const char *fn);	// Return: 1: OK, 0: Error opening file
        int Write(const char *fn);	// Return: 1: OK, 0: Error opening file
};


#endif
