/****************************************/
/*  KEYTABLE class                      */
/****************************************/
/* Start      : 27/9/1998               */
/* Program ID :                         */
/* Version    : 1.02                    */
/* End        :                         */
/* Last Update: 3/7/2001                */
/* Comments   : Table with string keys  */
/*              (dynamic table)         */
/****************************************/

#ifndef _KEYTABLE_CPP
#define _KEYTABLE_CPP

#error DEPRICATED - Use keytable2.cc

#include "keytable.h"
#include "v/mem/dlist3.cc"

template <class T> KEYTABLE<T>::KEYTABLE()
{
 NextID=1;
 lastsearch=NULL;
 count=0;
}

template <class T> KEYTABLE<T>::~KEYTABLE()
{
}

template <class T> long KEYTABLE<T>::Add(const LONGLINE& str, T p)
{
 KTOBJ<T> *pk;
 long l;

 l=-1;

/* if (!Exist(str))
 {
  KTOBJ<T> k;
  l=k.ID=NextID++;
  k.str=str;
  k.d=p;
  d.PushL(k);
  count++;
 }*/

 pk=GetKTO(str);	// v2.02 - 3/7/2001 begin changes

 if (pk==NULL)
 {
  KTOBJ<T> k;
  l=k.ID=NextID++;
  k.str=str;
  k.d=p;
  d.PushL(k);
  count++;
 } else
 {
  pk->d=p;
  l=pk->ID;
 }

 return(l);		// end changes
}

template <class T> long KEYTABLE<T>::Exist(const LONGLINE& s)
{
 long n=0;
 KTOBJ<T> *p;

 p=GetKTO(s);
 if (p!=NULL)
  n=p->ID;

 return(n);
}

template <class T> KTOBJ<T> *KEYTABLE<T>::GetKTO(const LONGLINE& s)
{
 KTOBJ<T> *p;

 p=lastsearch;
 if ((p==NULL) || (strcasecmp(p->str.p,s.p)))	// If we are allready there, don't search again. (6/1/2000)
 {
  d.Rewind();
  while ((p=d.Get_Next())!=NULL)
//  if (p->str==s) break;
   if (!(strcasecmp(p->str.p,s.p))) break;
 }

 return(p);
}

template <class T> T *KEYTABLE<T>::Get(const LONGLINE& str)
{
 KTOBJ<T> *p;
 T *t;

 t=NULL;
 
 p=GetKTO(str);
 if (p!=NULL)
  t=&(p->d);

 return(t);
}

template <class T> void KEYTABLE<T>::Del(const LONGLINE& str)
{
 KTOBJ<T> *p;

 p=GetKTO(str);

 if (p!=NULL)
 {
  d.RemoveItem(p);
  count--;
 }
}

template <class T> T *KEYTABLE<T>::operator[](const LONGLINE &str)
{
 return(Get(str));
}

template <class T> T *KEYTABLE<T>::operator[](const char *s)
{
 LONGLINE ll;
 ll=s;
 return(Get(ll));
}

template <class T> void KEYTABLE<T>::Rewind()
{
 d.Rewind();
}

template <class T> LONGLINE *KEYTABLE<T>::Get_Next()
{
 LONGLINE *p;
 KTOBJ<T> *t;
 t=d.Get_Next();

 if (t==NULL) p=NULL;
 else p=&(t->str);
 return(p);
}

template <class T> KEYTABLE<T>::KEYTABLE(KEYTABLE<T> &p)
{
 vvv(p);
// this->operator=(p);
}

template <class T> void KEYTABLE<T>::vvv(KEYTABLE<T>& p)
{
/* LONGLINE *s;

 ClearTable();
 p.Rewind();
 while ((s=p.Get_Next())!=NULL)
 {
  Add(*s,*p[*s]);
 }*/
 NextID=p.NextID;
 d=p.d;
 lastsearch=NULL;
 count=p.count;
}

template <class T> KEYTABLE<T> KEYTABLE<T>::operator=(KEYTABLE<T>& p)
{
 // KEYTABLE<T>::KEYTABLE(p);
 vvv(p);
 return(*this);
}

template <class T> void KEYTABLE<T>::ClearTable()
{
 d.ClearList();
 NextID=1;
 count=0;
}

#endif
