/****************************************/
/*  A fast indexed table 	*/
/****************************************/
/* Start      : 10/03/2002		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 10/03/2002		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_MISC_NKEYTABLE_H
#define _VLIB_V_MISC_NKEYTABLE_H

#include "v/lconfig.h"

/*
	Indexed table using 32bit integer as key
*/

/*
	**** NOTE NOTE NOTE NOTE NOTE NOTE NOTE ****
	****** WARNING WARNING WARNING WARNING *****
	**** NEVER EVER EVER USE KEY 0xFFFFFFFF ****

 */

#define NK_INVALID	(u_32)0xFFFFFFFF

// depth
#define	NK_DEPTH	8
#define	NK_WIDTH	16

template <class T> class NKEYTABLE
{
 private:
	struct	NK_FNODE
	{
		T		d;
		u_32		key;
		NK_FNODE	*prev,*next;
	};

 	struct	NK_NODE
	{
		union u_childs
		{
			NK_NODE		*nodes[NK_WIDTH];
			NK_FNODE	*fnodes[NK_WIDTH];
		} childs;
		int	count;
		char	level;
	};

	NK_NODE		hash_head;
	NK_FNODE	*head,*tail;
	NK_FNODE	*lastGetNext;
 public:
 	int	count;

 private:
	NK_FNODE	*MkFNode	(u_32 key);	// Ensure that the needed path exists
	void		CheckAndDel	(u_32 key);	// Remove uneeded nodes
	void		ZeroNode	(NK_NODE *pnode);	// Zero the node's data
	void		ClearNode	(NK_NODE *pnode);	// Delete this node and its childs
	NK_NODE		*GetLastNode	(u_32 key);	// return the last node.. not the fnode
	NK_FNODE	*GetFNode	(u_32 key);	// return the fnode
	NK_FNODE	*newFNode	();		// create a new fnode struct, link it to the list and return it
	void		deleteFNode	(NK_FNODE *fnode);	// unlink and fnode from the list and delete it

	void		init_nkt	();
	void		ddd		(NKEYTABLE<T> &d);
 public:
			NKEYTABLE	();
			~NKEYTABLE	();
			NKEYTABLE	(NKEYTABLE<T> &d);
	NKEYTABLE<T>	operator=	(NKEYTABLE<T> &d);

	void		ClearTable	();		// Clear table
	void		Add		(u_32 key, T data);
	void		Add		(u_32 key, T* data);
	T *		Get		(u_32 key);
	int		Exist		(u_32 key);	// Check if key exists
	void		Del		(u_32 key);

	void		Rewind		();
	u_32		Get_Next	();

	T *		operator[]	(u_32 key);

// TODO: operator= copy-constructor

/*  KEYTABLE2(KEYTABLE2<T,HS,MD> &p);
  KEYTABLE2 operator=(KEYTABLE2<T,HS,MD>& p);
  T *operator[](const LONGLINE &str);
  T *operator[](const char *s);*/
};


#endif

