/****************************************/
/*  Process things			*/
/****************************************/
/* Start      : 04/05/2002		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 04/05/2002		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_MISC_PROCESS_H
#define _VLIB_V_MISC_PROCESS_H

/*
	Disassociate the process from the controlling terminal
*/
void	disassociate_terminal();

/*
	Close all file descriptors

	all=1: Close them all
	all=2: Leave fd #0,#1 and #2 open (stdin,stdout,stderr)
*/
void	close_all_fds(int all=1);
/*
  	Same as close_all_fds() but leave specified fd open
 */
void	close_all_fds_except_one(int exfd, int all=1);

/*
	Get the FD soft and hard limit
	return -1 on error
*/
long	get_fdslimit();
long	get_fdhlimit();

/*
	Set the max core size..
	set_nocore() is equal to set_corelimit(0)
	return -1 on error
*/
void	set_nocore();
int	set_corelimit(long size);

/*
	Ignore some annoying stop signals
*/
void	ignore_stop_signals();

/*
	Do whatever is needed to become a daemon.
	tofork==1: do the fork too
	tofork==0: don't fork
*/
void	v_daemonize(int tofork=1);

/*
	NOTE: becoming daemon means that CWD is changed to /.
	Use:
		if (fork()==0) exit(0);		// This will cause ppid==1
		disassociate_terminal();
		ignore_stop_signals();
		close_all_fds();
	to avoid this (i.e. when spawning a child process)
*/
#endif

