/****************************************/
/*					*/
/****************************************/
/* Start      : 09/02/2002		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 09/02/2002		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_MISC_SSCHEDULER_H
#define _VLIB_V_MISC_SSCHEDULER_H

#include "v/mem/dlist3.h"

#include "time.h"

#include "scheduler.h"

// Simple scheduler
// Same as scheduler but for simple functions
class SSCHEDULER
{
 private:
 	typedef void (*hook_func)();
	struct SCH_ENTRY
	{
		int		ID;
		hook_func	func;
		time_t		next_run;
		time_t		interval;
		long		flags;
	};
	DL_List<SCH_ENTRY>	hooks;
	time_t			next_run;
 private:
 	SCH_ENTRY	*get	(hook_func func, int ID=0);
 public:
 		SSCHEDULER	();
		~SSCHEDULER	();
	void	Add		(time_t t, hook_func func, int flags=0, int ID=0);	// t specifies the seconds from now
											// if it exists, nothing is done
	void	Cancel		(hook_func func, int ID=0);
	time_t	Check		();	// Calls the wanted functions. Returns the time of the next run
	time_t	CalcNextRun	();	// This will return the time of next run
};

#endif

