/****************************************/
/*  TIMEWAITLIST class (header)         */
/****************************************/
/* Start      : 27/9/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 27/9/98                 */
/* Comments   : Timers list             */
/*                                      */
/****************************************/

#ifndef _VLIB_V_MISC_TIMEWAITLIST_H
#define _VLIB_V_MISC_TIMEWAITLIST_H

#include "timewait.h"
#include "v/mem/dlist3.h"
#include "v/minmax.h"

struct TWLOBJ // TIMEWAITLIST Object
{
 private:
  void vvv(TWLOBJ& p);
 public:
  TWLOBJ();
  TWLOBJ(TWLOBJ& p);
  TWLOBJ operator=(TWLOBJ& p);
  long ID;
  TIMEWAIT *tw;
};

class TIMEWAITLIST
{
 private:
  DL_List<TWLOBJ> d;
  long NextID;
 public:
  long AlarmN;  // AlarmCount
 private:
  TWLOBJ *GetIDTWLOBJ(long ID);
  
 public:
  TIMEWAITLIST();
  ~TIMEWAITLIST();
  long New();
  TIMEWAIT *GetID(long ID);
  int Delete(long ID);
  time_t GetNextAlarm();
  time_t GetSleepTime();
  long IsAlarm(); // Return 0 if there is no alarm, or the ID of the alarm
  long Sleep();   // Wait for an alarm and then return the ID (unless there is no alarm)

};

#endif

/*
 
 Usage:

 TIMEWAITLIST l;
 TIMEWAIT *p;
 long n;
 
 n=l.New();
 p=l.GetID(n);
 p->SetAlarm(1234L);
 ....
 l.Delete(n);
 
 */
