/****************************************/
/*  VAR class				*/
/****************************************/
/* Start      : 02/07/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 02/07/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "var.h"
#include "v/misc/keytable2.cc"
#include "v/mem/vtable.cc"

/***************************************************/
/*********************** DVAR **********************/
/***************************************************/

VAR::DVAR::DVAR()
{
	Construct();
}

VAR::DVAR::~DVAR()
{
}

void	VAR::DVAR::Construct()
{
//	dvtype=dvtype_int;
	dvtype=dvtype_null;
	iv=0;
	lv="";
}

VAR::DVAR::DVAR(VAR::DVAR &d)
{
 ddd(d);
}

VAR::DVAR VAR::DVAR::operator=(VAR::DVAR &d)
{
 if (!isNULLfixed())
 {
 	if (d.isNULLfixed())
		Construct();
	else
		ddd(d);
 }
 return (*this);
}

void VAR::DVAR::ddd(VAR::DVAR &d)
{
	iv=d.iv;
	lv=d.lv;
	dvtype=d.dvtype;
}

VAR::DVAR VAR::DVAR::operator=(int n)
{
	if (!isNULLfixed())
	{
		iv=n;
		dvtype=dvtype_int;
	}

	return (*this);
}

VAR::DVAR VAR::DVAR::operator=(const LONGLINE& ll)
{
	if (!isNULLfixed())
	{
		lv=ll;
		dvtype=dvtype_str;
	}
	return (*this);
}

VAR::DVAR::operator int()
{
	return((long)*this);
}

VAR::DVAR::operator long()
{
	long ret=0;

	switch(dvtype)
	{
		case dvtype_int:
			ret=iv;
			break;
		case dvtype_str:
			ret=(long)lv.len;
			break;
	}

	return(ret);
}

VAR::DVAR::operator char *()
{
	char 		*ret="";

	switch(dvtype)
	{
		case dvtype_int:
			lv="";
			lv+=(long)iv;
			ret=lv.p;
			break;
		case dvtype_str:
			ret=lv.p;
			break;
   		case dvtype_null:
		case dvtype_null_fixed:
			ret=NULL;
			break;
	}

	return(ret);
}

/*VAR::DVAR::operator LONGLINE()
{
	LONGLINE	ret="";

	switch(dvtype)
	{
		case dvtype_int:
			ret="";
			break;
		case dvtype_str:
			ret=lv;
			break;
	}

	return(ret);
}*/

VAR::DVAR::operator const LONGLINE&()
{
	switch(dvtype)
	{
		case dvtype_int:
			lv="";
			break;
	}

	return(lv);
}

VAR::DVAR::dvType VAR::DVAR::Type()
{
	return(dvtype);
}

int	VAR::DVAR::isNULL()
{
	int	ret;
	if ((dvtype==dvtype_null) || (isNULLfixed()))
		ret=1;
  	else
		ret=0;
	return(ret);
}

int	VAR::DVAR::isNULLfixed()
{
	return ( (dvtype==dvtype_null_fixed ? 1 : 0) );
}

VARNULL::DVARNULL::DVARNULL()
{
	dvtype=dvtype_null_fixed;
}

VARNULL::DVARNULL::~DVARNULL()
{
}


/***************************************************/
/*********************** VAR ***********************/
/***************************************************/

VARNULL			varnull_tmp;
VAR			varnull(varnull_tmp);
VARNULL::DVARNULL	dvarnull_tmp;
VAR::DVAR		dvarnull(dvarnull_tmp);

VAR::VAR(const char *name)
{
	data=NULL;
	Construct(name);
}

VAR::VAR(const LONGLINE& ll)
{
	data=NULL;
	Construct(ll.p);
}

void	VAR::Construct(const char *name)
{
//	varnull.vtype=vtype_null;
//	vtype=vtype_var;
//	vtype=vtype_null;
	settype(vtype_var);
	isNode=0;
	this->name=name;
	tsize=0;
	tmax=-1;
	Autocreate=1;
	allocdata();
}

VAR::~VAR()
{
	free(data);
}

VAR::VAR(VAR &d)
{
	data=NULL;
	allocdata();
	ddd(d);
}

void	VAR::allocdata()
{
	if (data==NULL)
		data=new DVAR;
}

VAR	VAR::operator=(VAR &d)
{
	if (!isNULL())
	{
		if (d.isNULL())
			Construct("");
		else
			ddd(d);
	}

	return (*this);
}

void VAR::ddd(VAR &d)
{
	VAR		*pv,**ppv;
	LONGLINE	*pll;
	long		*pn;

	Autocreate=d.Autocreate;
	(*data)=(*d.data);
	vtype=d.vtype;
	name=d.name;
//	table=d.table;
	ClearTable();
	d.table.Rewind();
	while ((pn=d.table.Get_Next())!=NULL)
	{
//		ppv=d.table[*pn];
		pv=new VAR();
		*pv=*d.table[*pn];
		table[*pn]=pv;
	}
	tsize=d.tsize;
	tmax=d.tmax;
	d.childs.Rewind();
	ClearChilds();
	while ((pll=d.childs.Get_Next())!=NULL)
	{
		ppv=d.childs[*pll];
		pv=new VAR();
		*pv=**ppv;
		childs.Add(*pll,pv);
	}
	ClearList();
	d.list.Rewind();
	while ((ppv=d.list.Get_Next())!=NULL)
	{
		pv=new VAR(**ppv);
		PushL(*pv);
	}
}

VAR::operator long()
{
	return(*data);
}

VAR::operator int()
{
	return(*data);
}

VAR::operator char *()
{
	return(*data);
}

/*VAR::operator LONGLINE()
{
	return((LONGLINE)*data);
}*/

VAR::operator const LONGLINE&()
{
	return(*data);
}

VAR	VAR::operator=(int n)
{
	*data=n;
	return(*this);
}

VAR	VAR::operator=(long n)
{
//	if (!isNULL())
	*data=n;
	return(*this);
}

VAR	VAR::operator=(const LONGLINE& ll)
{
//	if (!isNULL())
	*data=ll;
	return(*this);
}

void	VAR::settype(vType v)
{
	if (vtype!=v)
	{
		switch(vtype)
		{
			case vtype_var:
				break;
	   		case vtype_null:
				Autocreate=0;
				ClearTable();
				ClearChilds();
				ClearList();
				break;
		}

		vtype=v;
	}
}

VAR	*VAR::AddChild(const char *Name)
{
	VAR		*pv,**ppv;
	LONGLINE	ll;

	if (isNULL()) pv=NULL;
	else
	{
		isNode=1;
		ppv=childs[Name];
		if (ppv==NULL)
		{
			pv=new VAR(Name);
			ll=Name;
			ll.Uppercase();
			childs.Add(Name,pv);
	  	} else pv=*ppv;
	}

	return(pv);
}

void	VAR::ClearTable()
{
	VAR		*pv;
	long		*pl;

	table.Rewind();
	while ((pl=table.Get_Next())!=NULL)
	{
		pv=table[*pl];
		free(*pv);
	}

	table.Clear();
	tsize=0;
	tmax=-1;
}

void	VAR::ClearChilds()
{
	VAR		**ppv;
	LONGLINE	*pll;

	childs.Rewind();
	while ((pll=childs.Get_Next())!=NULL)
	{
		ppv=childs[*pll];
		free(*ppv);
	}

	childs.ClearTable();
	isNode=0;
}

void	VAR::ClearList()
{
	VAR	**ppv;

	list.Rewind();
	while ((ppv=list.Get_Next())!=NULL)
		free(*ppv);
	list.ClearList();
}

//VAR::DVAR& VAR::operator[](long index)
VAR&	VAR::operator[](long index)
{
//	VAR::DVAR	*ret=&dvarnull;
	VAR	*ret=&varnull;

	if (!isNULL())
	{
		if (table.Exist(index)==NULL)
		{
			if (Autocreate)
			{
				if (index>tmax) tmax=index;
				tsize++;
				ret=new VAR;
				table[index]=ret;
    			}
       		} else ret=table[index];
  	}

	return(*ret);
}

VAR&	VAR::operator[](int index)
{
	return(this->operator[]((long)index));
}

//VAR 	*VAR::operator[](const char *Name)
VAR 	&VAR::operator[](const char *Name)
{
	VAR	**ppv,*ret;

	if (!isNULL())
	{
		ppv=childs[Name];
		if (ppv==NULL)
		{
			if (Autocreate)
				ret=AddChild(Name);
	   		else
				ret=&varnull;
		} else ret=*ppv;
	} else ret=&varnull;
//	return( (ppv==NULL ? NULL : *ppv) );
	return( *ret );
}

VAR 	*VAR::cExist(const char *Name)
//VAR 	&VAR::operator[](const char *Name)
{
	VAR	**ppv;
//	VAR	empty;

	if (!isNULL())
		ppv=childs[Name];
	else
		ppv=NULL;

	return( (ppv==NULL ? NULL : *ppv) );
//	return( (ppv==NULL ? empty : **ppv) );
}

void	VAR::Rewind()
{
	list.Rewind();
}

VAR	*VAR::Get_Next()
{
	VAR	*ret=NULL,**ppv;

	if (!isNULL())
	{
		ppv=list.Get_Next();
		if (ppv==NULL)
			ret=NULL;
   		else
			ret=*ppv;
	}

	return(ret);
}

void	VAR::Push(VAR &v)
{
	VAR	*pv;

	pv=new VAR(v);
	list.Push(pv);
}

void	VAR::PushL(VAR &v)
{
	VAR	*pv;

	pv=new VAR(v);
	list.PushL(pv);
}

void	VAR::PushL(int n)
{
	PushL((long)n);
}

void	VAR::PushL(long n)
{
	VAR	v;
	v=n;
	PushL(v);
}

void	VAR::PushL(const LONGLINE& ll)
{
	VAR	v;
	v=ll;
	PushL(v);
}

void	VAR::Push(int n)
{
	Push((long)n);
}

void	VAR::Push(long n)
{
	VAR	v;
	v=n;
	Push(v);
}

void	VAR::Push(const LONGLINE& ll)
{
	VAR	v;
	v=ll;
	Push(v);
}

VAR	VAR::Pop()
{
	VAR 	*ret=NULL,**ppv,tmp;

	ppv=list.Pop();
	if (ppv!=NULL)
	{
		tmp=**ppv;
		free(*ppv);
		ret=&tmp;
	}

	return( (ret==NULL ? varnull : *ret) );
}

VAR	VAR::PopL()
{
	VAR 	*ret=NULL,**ppv,tmp;

	ppv=list.Pop();
	if (ppv!=NULL)
	{
		tmp=**ppv;
		free(*ppv);
		ret=&tmp;
	}

	return( (ret==NULL ? varnull : *ret) );
}

void	VAR::RemoveCurrent()
{
	VAR	**ppv;

	list.Get_Prev();
	ppv=list.Get_Next();
	if (ppv!=NULL)
		free(*ppv);

	list.RemoveCurrent();
}

void	VAR::Dump(int depth,int index)
{
	int		n;
	long		*pn;
	LONGLINE	la,ll,*pll,lb,lc;
	VAR		**ppv,*pv;

	if (isNULL())
	{
		printf("*NULL*\n");
		return;
	}

	la="";
	for (n=0;n<depth-1;n++)
		la+="|  ";
  	lc=lb=la;
	if (depth)
	 {lb+="+--"; lc+="|  ";}
  	lb+="+--";lc+="|  ";

//  	for (n=depth; n>=0; n--)
//		la+="+--";
	if (index==-1)
	  	printf("%s[%s]\n",lb.p,name.p);
	else if (index==-2)
		printf("%s[-]\n",lb.p);
	else
		printf("%s[%d]\n",lb.p,index);
	printf("%s[int=%d] [str=%s]\n",lc.p,(int)*data,(char *)*data);
	table.Rewind();
/*	ll="";
	while ((pn=table.Get_Next())!=NULL)
	{
		ll+="{";
		ll+=*pn;
		ll+=":";
		ll+=(long)(int)(*table[*pn]);
		ll+="/";
		ll+=(char *)(*table[*pn]);
		ll+="} ";
	}
	ll--;
	printf("%s[table=%s]\n",lc.p,ll.p);*/
	while ((pn=table.Get_Next())!=NULL)
	{
		pv=table[*pn];
		pv->Dump(depth+1,*pn);
	}

	childs.Rewind();
	while ((pll=childs.Get_Next())!=NULL)
	{
		ppv=childs[*pll];
		(*ppv)->Dump(depth+1);
	}
	list.Rewind();
	while ((ppv=list.Get_Next())!=NULL)
	{
		(*ppv)->Dump(depth+1,-2);
	}
}

int	VAR::isNULL()
{
	return( (vtype==vtype_null ? 1 : 0) );
}

VAR::operator VAR::DVAR&()
{
	return(*data);
}

void	VAR::Clear()
{
	free(data);
	data=NULL;
	Construct("");
	ClearTable();
	ClearChilds();
	ClearList();
}

void	VAR::autocreate(int n)
{
	VAR		**ppv;
	LONGLINE	*pll;
	long		*pn;
	void		*save;

	childs.Rewind();
	while ((pll=childs.Get_Next())!=NULL)
	{
		(*childs[*pll])->autocreate(n);
	}

	table.Rewind();
	while ((pn=table.Get_Next())!=NULL)
	{
		table[*pn]->autocreate(n);
	}

	save=list.SaveState(DL_LIST_STATE_NEW);
	list.Rewind();
	while ((ppv=list.Get_Next())!=NULL)
	{
		(*ppv)->autocreate(n);
	}
	list.RestoreState(save);

	Autocreate=n;

}

VARNULL::VARNULL()
{
	settype(vtype_null);
}

VARNULL::~VARNULL()
{
}

void VARNULL::allocdata()
{
	int	n;

	n=Autocreate;
	data=new DVARNULL;
	Autocreate=n;
}

