/****************************************/
/*  IPADDR class (header)               */
/****************************************/
/* Start      : 10/1/1999               */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 10/1/1999               */
/* Comments   : Convert IP addreses     */
/*             (string, long, etc...)   */
/****************************************/

#ifndef _VLIB_V_SOCKET_IPADDR_H
#define _VLIB_V_SOCKET_IPADDR_H

#include "v/lconfig.h"

#include "arpa/inet.h"
#include "netinet/in.h"
#include "string.h"

#ifndef _MAX_HOSTNAME
#define _MAX_HOSTNAME 20  /* Max is 15 (255.255.255.255)=(3*4+3=15) */
#endif

/*
 Assuming that the ip is in a host-byte-ordered 32 bit integer
 ipaddr.s_addr is in network byte order
 */

class IPADDR
{
 private:
 public:
  long ip;
  char hostname[_MAX_HOSTNAME+1];  // The hostname's ip in a string: 127.0.0.1 etc.
  struct in_addr ipaddr;
 private:
  void ddd(IPADDR &d);
  void convert(IPLONG ip);
  void convert(struct in_addr &inaddr);
  void convert(const char *hostname);
  void copy_hostname(const char *p);
 public:
  IPADDR();
  ~IPADDR();
  IPADDR(IPADDR &d);
  IPADDR operator=(IPADDR &d);
  long operator=(long ip);
  struct in_addr operator=(struct in_addr &inaddr);
  const char *operator=(const char *hostname);
/*  long();
  struct in_addr();
  *char();*/
};

#endif
