/****************************************/
/*					*/
/****************************************/
/* Start      : 10/12/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 10/12/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "netbuf.h"

#include "v/mem/dlist3.cc"

#define BUFFER_SIZE	8190
#define	WRITE_BLOCK	1020

NETBUF::NETBUF(const SOCKET &s)
{
	WaitRead=1;
	WaitWrite=0;
	WaitExcept=1;
	SetSocket(s);
}

NETBUF::NETBUF(const SOCKET_COMMON &s)
{
	WaitRead=1;
	WaitWrite=0;
	WaitExcept=1;
	SetSocket(s);
}

NETBUF::NETBUF()
{
	WaitRead=1;
	WaitWrite=0;
	WaitExcept=1;
	this->fd=-1;
}

NETBUF::~NETBUF()
{
}

void	NETBUF::SetSocket(const SOCKET &s)
{
	this->s=s;
	this->fd = s.sockfd;
}

void	NETBUF::SetSocket(const SOCKET_COMMON &s)
{
	this->s=s;
	this->fd = s.sockfd;
}

int	NETBUF::RunRead()
{
	SOCKET_COMMON	sock(s);
	ssize_t		len;
	char		buf[BUFFER_SIZE+1];
	int		ret=0;

	len=sock.Read(buf,BUFFER_SIZE);	// for each data block
	if (len<=0)	// Error
	{
		Reject();
		return(_SELECT_DEREGISTER);
	}

	in.Push(buf,len); // store it in the queue

	ret=OnRead();

	return(ret);
}

int	NETBUF::RunWrite()
{
	SOCKET_COMMON	sock(s);
	size_t		len;
	char		buf[WRITE_BLOCK+1];
	int		ret=0;

	len=out.PopNoErase(buf,WRITE_BLOCK);	// get max WRITE_BLOCK data
	len=sock.Write(buf,len);	// try to send them

	if (len>0)
		out.Discard(len);	// remove those send

	if (out.Size()==0)
		WaitWrite=0;		// If we are done, then we don't want to write any more

	if (len<=0)
	{
		Reject();
		ret=_SELECT_DEREGISTER;
	}


	return(ret);
}

int	NETBUF::RunExcept()
{
	Reject();
	return(_SELECT_DEREGISTER);
}

void	NETBUF::Reject()
{
	SOCKET_COMMON	sc(s);

	OnReject();

	sc.Close();
//	delete(this);
}

void	NETBUF::Write(const char *buf, size_t len)
{
	out.Push(buf,len);	// and the data
	WaitWrite=1;		// set the write flag
}

int	NETBUF::OnRead()
{
	return(0);
}

void	NETBUF::OnReject()
{
}

int	NETBUF::Run()
{
	return(0);
}
