/****************************************/
/*					*/
/****************************************/
/* Start      : 10/12/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 10/12/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

/*
	Net Buffer

	This class should be used with SOCKETCONTROL

	Reads/Write data from/to a socket and calls
	OnRead() when new data came.
*/

#ifndef _VLIB_V_SOCKET_NETBUF_H
#define _VLIB_V_SOCKET_NETBUF_H

#include "v/mem/bytequeue.h"
//#include "v/socket/socket2.h"
#include "v/socket/socket3.h"
#include "v/socket/sbase.h"

class NETBUF : public SOCKETBASE
{
 private:
 protected:
 	ByteQueue		in,out;
 public:
 	SOCKET_COMMON		s;
 private:
 protected:
	void 	Reject		();

	virtual int OnRead	();	// call this when data came	// return 0, _SELECT_DONE or _SELECT_DEREGISTER // see sbase.h
	virtual void OnReject	();	// call this when closing connection	// same as above
 public:
 		NETBUF		();
 		NETBUF		(const SOCKET &s);
		NETBUF		(const SOCKET_COMMON &s);
	virtual	~NETBUF		();

	void	SetSocket	(const SOCKET &s);
	void	SetSocket	(const SOCKET_COMMON &s);

	virtual int Run		();
	int	RunRead		();
	int	RunWrite	();
	int	RunExcept	();

	void	Write		(const char *buf, size_t len);	// write data
};

#endif

