/****************************************/
/*					*/
/****************************************/
/* Start      : 10/12/2001		*/
/* Program ID : 			*/
/* Version    : 1.01			*/
/* End        : 			*/
/* Last Update: 11/03/2002		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "netbuf_line.h"
#include "v/mem/dlist3.cc"

/*
	11/03/2002	v1.01:	bug fix. last line is not lost after disconnection
*/

NETBUF_LINE::NETBUF_LINE()
{
}

NETBUF_LINE::NETBUF_LINE(const SOCKET &s) : NETBUF(s)
{
}

NETBUF_LINE::NETBUF_LINE(const SOCKET_COMMON &s) : NETBUF(s)
{
}

NETBUF_LINE::~NETBUF_LINE()
{
}

int	NETBUF_LINE::OnLine(const char *line)
{
	return(0);
}

void	NETBUF_LINE::OnReject()
{
	if (in.Size()>0)	// if there are remaining data
	{
		in.Push("\n",1);	// append a LF
		OnRead();		// and check this
	}
}

int	NETBUF_LINE::OnRead()
{
	int	ret;

	check_in();
	ret=check_lines();

	return(ret);
}

/*
	Get another line if available
	return: 1: got a line
		0: No line was available
*/
int	NETBUF_LINE::get_line()
{
	int		ret=0;
	char		buf[1025];
	int		OK=0;
	long		n;
	char		*p;
	LONGLINE	ll;

	buf[1024]=0;
	ll="";

	while (!OK)	// find the first new line (if any)
	{
		n=in.Pop(buf,1024);	// try to get 1024 more bytes
		if (!n)	// no more bytes
		{
			OK=-1;
			if (ll.len)
				in.UnPop(ll.p,ll.len);	// put those back
		} else
		{
			buf[n]=0;
			p=strchr(buf,'\n');		// search for a new line
			if (p!=NULL)	// got it!
			{
				*p=0;
				if ((p>buf) && (*(p-1)=='\r'))
					*(p-1)=0;	// also clear \r (if there is one before \n)
				if (buf[0]=='\r')	// ignore the first char if it is a \r
					ll+=buf+1;
				else
					ll+=buf;
				n-=(p-buf)+1;
				if (n) in.UnPop(p+1,n);	// put the rest back
				OK=1;
				inlines.PushL(ll);	// store this one
				ll="";			// clear the buffer
				ret=1;
			} else
			{
				ll+=buf;
			}
		}
	}

	return(ret);
}

void	NETBUF_LINE::check_in()
{
	int	n;

	do {
		n=get_line();
	} while (n);
}

int	NETBUF_LINE::check_lines()
{
	LONGLINE	*pll;
	int		ret;

	inlines.Rewind();

	while ((pll=inlines.Pop())!=NULL)
	{
		ret=OnLine(pll->p);
		if (ret)
			return(ret);
	}

	return(0);
}

void	NETBUF_LINE::check_out()
{
	LONGLINE	*pll;

	while ((pll=outlines.Pop())!=NULL)
	{
		NETBUF::Write(pll->p, pll->len);
	}
}

void	NETBUF_LINE::Write(const char *line)
{
	LONGLINE	ll;

	ll=line;
	outlines.PushL(ll);
	check_out();
}

