/****************************************/
/*					*/
/****************************************/
/* Start      : 10/12/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 10/12/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

/*
	Line - Net Buffer

	Reads/Writes Lines from/to network

	Lines will NOT contain \n
*/

#ifndef _VLIB_V_SOCKET_NETBUF_PACKET_H
#define _VLIB_V_SOCKET_NETBUF_PACKET_H

#include "v/mem/dlist3.h"
#include "v/mem/longline.h"

#include "netbuf.h"

class NETBUF_LINE : public NETBUF
{
 private:
 protected:
 	DL_List<LONGLINE>	inlines, outlines;
 public:
 private:
 	int		get_line	();	// get another line from input buffer // return: 1:OK, 0:No line was available
 	void		check_in	();	// check input buffer and fill inlines
 	int		check_lines	();	// for each line call OnLine()	// stop, when a OnLine() returns NOT 0.
						// return the return valut of last OnLine()
	void		check_out	();	// check outlines and fill output buffer
 protected:
 	int		OnRead		();
 public:
 			NETBUF_LINE	();
 			NETBUF_LINE	(const SOCKET &s);
 			NETBUF_LINE	(const SOCKET_COMMON &s);
	virtual		~NETBUF_LINE	();

	virtual int	OnLine		(const char *line);	// Call this when a line came - for each line 
	virtual void	OnReject	();

	void		Write		(const char *line);	// Write a line
};

#endif

