/****************************************/
/*  Extract symbols                     */
/****************************************/
/* Start      : 21/2/99 (24/10/96)      */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 21/2/99                 */
/* Comments   : Extract symbols from    */
/*    a string (based on vmask)         */
/****************************************/

#include "extrsym.h"
#include "v/mem/dlist3.cc"

#define GS_PERCENT -2
#define GS_SPACES -3
#define GS_INVALID -1

/*
 original_string=="test %15%"
 str=="15"
 getsize will return 15.

 original_string=="test %%"
 str==""
 getsize will return -2.

 original_string=="test "S"
 str=="S"
 getsize will return -3.

 else getsize will return -1
 */

int getsize(char *str)
{
 int ret=GS_INVALID;
 char *s;

 if (str[0]==0)  /* First check for the case of %% */
  ret=GS_PERCENT;
 else
 {
  if (isdigit(str[0])) /* else see if it is a number */
  {
   ret=strtol(str,&s,10); /* convert it */
   if (*s!=0)  /* Check for errors */
    ret=GS_INVALID;
  } else /* then check for %S% */
  if (str[1]==0)
   if ((str[0]=='s') || (str[0]=='S'))
    ret=GS_SPACES;
 }

 return(ret);
}




int extrsym2(char *name,char *mask,DL_List<LONGLINE> *p) //return 0 if error, 1 if ok, -1 syntax error
{
 int done=0;    //0: not done, 1:ok, 2:error
 int npos=0,mpos=0;
 int star=0;
 char c,d;
 int n;
 LONGLINE extr;
 DL_List<LONGLINE> p2;
 
 while (!done)
 {
  d=name[npos];
  switch ((c=mask[mpos]))
  {
  case '?': npos++;mpos++;star=0;break;
  case '*': /*while (mask[mpos]=='*')*/ mpos++;
            star=1;
            goto LAB1;
            break;
  case 0  : /*if (star)
            {            //Check if there are no more chars after the star
             //c=mask[mpos];
             //             while ((c) && ((c=='*') || (c=='?'))) c=mask[++mpos];  //? should be one char not 0
             while (c=='*') c=mask[++mpos];
             if (c) done=2; else done=1;
            } else
            if (!d) done=1; else done=2;  //The name should be allready matched
            break;*/
            if (star)
            {
             done=1;
            }
            else
             if (!d) done=1; else done=2;
            break;
   case '%':
    c=mask[++mpos];
    extr="";
    while ((c) && (c!='%')) /* Extract the symbol inside %% */
    {
     extr+=c;
     c=mask[++mpos];
    }
    if (!c)  /* If the mask ends without finding second %, then there is an error */
    {
     done=3;
    } else
    {
     n=getsize(extr.p); /* Translate extr */
     do {
      c=mask[mpos++];
     } while ((c) && (c!='%'));
     switch(n)
     {
      case -3: /* Spaces */ /* This should exist in Check_Name... It is a matching symbol, not used for symbol extraction */
       do {
        c=name[npos++];
       } while ((c) && (c==' '));
       npos--;
       break;
      case -2: /* %% */
       mpos--;
       star=0;
       c=mask[mpos]; d=name[npos];
       goto LAB1;
       break;
      case -1: /* getsize found an error */
       done=3;
       break;
      case 0: /* Unknown size of symbol */
       n=0;
       extr="";
       while ((!n) && (name[npos]))
       {
        n=extrsym2(&name[npos],&mask[mpos],&p2);
        if (!n)
        {
         extr+=name[npos];
         npos++;
        }
       }
       if ((!name[npos]) && (!mask[mpos])) /* In case we have a %0% at the end*/
        n=1;
       switch(n)
       {
        case 1: /* OK */
         done=1;
         p->PushL(extr);
         (*p)+=p2;
         break;
        case -1: /* Syntax error */
         done=3;
         break;
        case 0: /* Mismatch */
         done=2;
       }
       break;
       
      default: /* Fixed size of symbol */
       extr="";
       for (;n>0;n--)
       {
        c=name[npos++];
        if (c)
         extr+=c;
        else
        {
         n=-1;
         done=2;
        }
       }
       p->PushL(extr);

     }
    }
    break;

   default :/* if (star)     // ERROR!!!!!! a*a != aaa (Found *, search for a, found the 2nd a, keep on.. No match for the 3rd(!!! :))
            {
             while ((c!=d) && (d)) d=name[++npos];
             if (!d) done=2; else {mpos++;npos++;}
             star=0;
             } else*/
LAB1:
             if (star)
             {
              n=0;
              while ((!n) && (name[npos]))
              {
               p2.ClearList();
               n=extrsym2(&name[npos],&mask[mpos],&p2);
               if (!n)
                npos++;
              };
              switch(n)
              {
               case 1: /* OK */
                done=1;
                (*p)+=p2;
                break;
               case -1: /* Syntax error */
                done=3;
                break;
               case 0: /* Mismatch */
                done=2;
              }
             } else
            {
             if (c!=d) done=2; else {mpos++;npos++;}
            }
            break;
  }
 }
 if (done==2) done=0;
 else if (done==3) done=-1;
 return(done);
}
