/****************************************/
/*  Extract symbols (header)            */
/****************************************/
/* Start      : 21/2/99 (24/10/96)      */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 21/2/99                 */
/* Comments   : Extract symbols from    */
/*    a string (based on vmask)         */
/****************************************/

#ifndef _VLIB_V_STRING_EXTRSYM_H
#define _VLIB_V_STRING_EXTRSYM_H

#include "v/mem/dlist3.h"
#include "v/mem/longline.h"

#include "ctype.h"

/*
 Extract symbols from str, using mask and store them to *p.
 (Will not clear the DL_List. It will only append to it.

 %0% : Unknown size
 %N% : N chars long
 %%  : The % symbol
 %S% : Match the spaces (It will match ALL the spaces, so "%S% mplampla"
      is invalid)

 
 */


int extrsym2(char *str, char *mask, DL_List<LONGLINE> *p); /* 0 error, 1 ok, -1 syntax error */


#endif
