/****************************************/
/*  Error class                         */
/****************************************/
/* Start      : 24/5/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 27/5/98                 */
/* Comments   :                         */
/*                                      */
/****************************************/


#include "verror.h"

ERROR::ERROR()
{
 ClearErrorTableMask();
}

ERROR::~ERROR()
{
}

ERROR::ERROR(ERROR& p)
{
 vvv(p);
}

void ERROR::vvv(ERROR& p)
{
 int n;

 for (n=0;n<_ERROR_MAX_ERR;n++)
  SetErrorTableMask(n,GetErrorTableMask(n));
}

void ERROR::SetErrorTableMask(int x, int y)
{
 int n,k;
 unsigned char c;
 n=x/8;
 c=ErrorTableMask[n];
 k=x%8;
 c&=(255 ^ (1<<k));
 c|=( (y ? 1 : 0) <<k );
 ErrorTableMask[n]=c;
}

int ERROR::GetErrorTableMask(int x)
{
 int n,k;
 unsigned char c;
 n=x/8;
 c=ErrorTableMask[n];
 k=x%8;
 c=c&(1<<k);
 return(c>>k);
}

void ERROR::ClearErrorTableMask()
{
 int n,m;
 n=( (_ERROR_MAX_ERR+1) / 8 ) + 1;
 for (m=0;m<n;m++)
  ErrorTableMask[m]=(unsigned char)0;
}

void ERROR::SetAllErrorTableMask()
{
 int n,m;
 n=( (_ERROR_MAX_ERR+1) / 8 ) + 1;
 for (m=0;m<n;m++)
  ErrorTableMask[m]=(unsigned char)1;
}

int ERROR::Handler()
{
 return(Handler(Errno));
}

int ERROR::Handler(int n)
{
 Errno=n;
 if (GetErrorTableMask(n))
 {
  ShowMsg(n);
 }
 return(Errno);
}

void ERROR::ShowMsg(int n)
{
 printf("Error: %d\n",n);
 perror(NULL);
}

int ERROR::SetErr(int n)
{
 Errno=n;
 return(Errno);
}

void ERROR::Halt()
{
 Halt(Errno);
}

void ERROR::Halt(int n)
{
 ShowMsg(n);
 printf(" Exiting... \n");
 Exit(n);
}

void ERROR::Exit(int n)
{
 exit(-1*n);
}

#ifdef _DEBUG_

void ERROR::ShowErrorTableMask()
{
 int n,m;
 for (n=0;n<((_ERROR_MAX_ERR+1)/64);n++)
 {
  printf(" %4d> ",n*64);
  for (m=0;m<64;m++)
   printf ("%d",GetErrorTableMask(m+(n*64)));
  printf("\n");
 }
}

#endif
