/****************************************/
/*  Error class                         */
/****************************************/
/* Start      : 24/5/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 27/5/98                 */
/* Comments   :                         */
/*                                      */
/****************************************/

#ifndef _VLIB_V_ERROR_H
#define _VLIB_V_ERROR_H

#include "limits.h"
#include "stdio.h"
#include "errno.h"
#include "stdlib.h"

#define _ERROR_MAX_ERR 4096

typedef unsigned char ErrTbl[ ( (_ERROR_MAX_ERR+1) / 8 ) + 1];


class ERROR
{
 private:
  ErrTbl ErrorTableMask;
 protected:
  int Errno;
 public:
 private:
  void vvv(ERROR& p);
  void ClearErrorTableMask();
  void SetAllErrorTableMask();
  void ShowMsg(int n);
  void Halt();
  void Halt(int n);
  void Exit(int n);
 public:
  ERROR();
  virtual ~ERROR();
  ERROR(ERROR& p);
  void SetErrorTableMask(int x , int y);
  int GetErrorTableMask(int x);
  int Handler();
  int Handler(int n);
  int SetErr(int n);
  
#ifdef _DEBUG_
  void ShowErrorTableMask();
#endif
  
};

#endif

